/* A Bison parser, made by GNU Bison 3.8.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30802

/* Bison version string.  */
#define YYBISON_VERSION "3.8.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* First part of user prologue.  */
#line 20 "sg.y"

#include "sg.h"
extern int globalDebug;
#ifdef USE_SYSLOG
extern int globalSyslog;
#endif

#ifdef HAVE_LIBLDAP
#include "lber.h"
#include "ldap.h"
#endif

#ifdef HAVE_MYSQL
#include <mysql.h>
#endif

#include "sgEx.h"

FILE *yyin, *yyout;
char *configFile;

int numTimeElements;
int *TimeElementsEvents;

static int time_switch = 0;
static int date_switch = 0;

int numSource = 0;

void sgSourceUserQuery(char *query);

void rfc1738_unescape(char *);
void
rfc1738_unescape(char *s)
{
    char hexnum[3];
    int i, j;                   /* i is write, j is read */
    unsigned int x;
    for (i = j = 0; s[j]; i++, j++) {
        s[i] = s[j];
        if (s[i] != '%')
            continue;
        if (s[j + 1] == '%') {  /* %% case */
            j++;
            continue;
        }
        if (s[j + 1] && s[j + 2]) {
            if (s[j + 1] == '0' && s[j + 2] == '0') {   /* %00 case */
                j += 2;
                continue;
            }
            hexnum[0] = s[j + 1];
            hexnum[1] = s[j + 2];
            hexnum[2] = '\0';
            if (1 == sscanf(hexnum, "%x", &x)) {
                s[i] = (char) (0x0ff & x);
                j += 2;
            }
        }
    }
    s[i] = '\0';
}


#line 136 "y.tab.c"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

/* Use api.header.include to #include this header
   instead of duplicating it here.  */
#ifndef YY_YY_Y_TAB_H_INCLUDED
# define YY_YY_Y_TAB_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Token kinds.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    YYEMPTY = -2,
    YYEOF = 0,                     /* "end of file"  */
    YYerror = 256,                 /* error  */
    YYUNDEF = 257,                 /* "invalid token"  */
    WORD = 258,                    /* WORD  */
    END = 259,                     /* END  */
    START_BRACKET = 260,           /* START_BRACKET  */
    STOP_BRACKET = 261,            /* STOP_BRACKET  */
    WEEKDAY = 262,                 /* WEEKDAY  */
    DESTINATION = 263,             /* DESTINATION  */
    REWRITE = 264,                 /* REWRITE  */
    ACL = 265,                     /* ACL  */
    TIME = 266,                    /* TIME  */
    TVAL = 267,                    /* TVAL  */
    DVAL = 268,                    /* DVAL  */
    DVALCRON = 269,                /* DVALCRON  */
    SOURCE = 270,                  /* SOURCE  */
    CIDR = 271,                    /* CIDR  */
    IPCLASS = 272,                 /* IPCLASS  */
    CONTINUE = 273,                /* CONTINUE  */
    IPADDR = 274,                  /* IPADDR  */
    DBHOME = 275,                  /* DBHOME  */
    DOMAINLIST = 276,              /* DOMAINLIST  */
    URLLIST = 277,                 /* URLLIST  */
    EXPRESSIONLIST = 278,          /* EXPRESSIONLIST  */
    IPLIST = 279,                  /* IPLIST  */
    DOMAIN = 280,                  /* DOMAIN  */
    USER = 281,                    /* USER  */
    USERLIST = 282,                /* USERLIST  */
    USERQUERY = 283,               /* USERQUERY  */
    LDAPUSERSEARCH = 284,          /* LDAPUSERSEARCH  */
    USERQUOTA = 285,               /* USERQUOTA  */
    LDAPIPSEARCH = 286,            /* LDAPIPSEARCH  */
    IPQUOTA = 287,                 /* IPQUOTA  */
    IP = 288,                      /* IP  */
    NL = 289,                      /* NL  */
    NUMBER = 290,                  /* NUMBER  */
    PASS = 291,                    /* PASS  */
    REDIRECT = 292,                /* REDIRECT  */
    LOGDIR = 293,                  /* LOGDIR  */
    SUBST = 294,                   /* SUBST  */
    CHAR = 295,                    /* CHAR  */
    MINUTELY = 296,                /* MINUTELY  */
    HOURLY = 297,                  /* HOURLY  */
    DAILY = 298,                   /* DAILY  */
    WEEKLY = 299,                  /* WEEKLY  */
    DATE = 300,                    /* DATE  */
    WITHIN = 301,                  /* WITHIN  */
    OUTSIDE = 302,                 /* OUTSIDE  */
    ELSE = 303,                    /* ELSE  */
    LOGFILE = 304,                 /* LOGFILE  */
    SYSLOG = 305,                  /* SYSLOG  */
    ANONYMOUS = 306,               /* ANONYMOUS  */
    VERBOSE = 307,                 /* VERBOSE  */
    CONTINIOUS = 308,              /* CONTINIOUS  */
    SPORADIC = 309,                /* SPORADIC  */
    LDAPCACHETIME = 310,           /* LDAPCACHETIME  */
    EXECUSERLIST = 311,            /* EXECUSERLIST  */
    EXECCMD = 312,                 /* EXECCMD  */
    LDAPPROTOVER = 313,            /* LDAPPROTOVER  */
    LDAPBINDDN = 314,              /* LDAPBINDDN  */
    LDAPBINDPASS = 315,            /* LDAPBINDPASS  */
    MYSQLUSERNAME = 316,           /* MYSQLUSERNAME  */
    MYSQLPASSWORD = 317,           /* MYSQLPASSWORD  */
    DATABASE = 318,                /* DATABASE  */
    QUOTED_STRING = 319            /* QUOTED_STRING  */
  };
  typedef enum yytokentype yytoken_kind_t;
#endif
/* Token kinds.  */
#define YYEMPTY -2
#define YYEOF 0
#define YYerror 256
#define YYUNDEF 257
#define WORD 258
#define END 259
#define START_BRACKET 260
#define STOP_BRACKET 261
#define WEEKDAY 262
#define DESTINATION 263
#define REWRITE 264
#define ACL 265
#define TIME 266
#define TVAL 267
#define DVAL 268
#define DVALCRON 269
#define SOURCE 270
#define CIDR 271
#define IPCLASS 272
#define CONTINUE 273
#define IPADDR 274
#define DBHOME 275
#define DOMAINLIST 276
#define URLLIST 277
#define EXPRESSIONLIST 278
#define IPLIST 279
#define DOMAIN 280
#define USER 281
#define USERLIST 282
#define USERQUERY 283
#define LDAPUSERSEARCH 284
#define USERQUOTA 285
#define LDAPIPSEARCH 286
#define IPQUOTA 287
#define IP 288
#define NL 289
#define NUMBER 290
#define PASS 291
#define REDIRECT 292
#define LOGDIR 293
#define SUBST 294
#define CHAR 295
#define MINUTELY 296
#define HOURLY 297
#define DAILY 298
#define WEEKLY 299
#define DATE 300
#define WITHIN 301
#define OUTSIDE 302
#define ELSE 303
#define LOGFILE 304
#define SYSLOG 305
#define ANONYMOUS 306
#define VERBOSE 307
#define CONTINIOUS 308
#define SPORADIC 309
#define LDAPCACHETIME 310
#define EXECUSERLIST 311
#define EXECCMD 312
#define LDAPPROTOVER 313
#define LDAPBINDDN 314
#define LDAPBINDPASS 315
#define MYSQLUSERNAME 316
#define MYSQLPASSWORD 317
#define DATABASE 318
#define QUOTED_STRING 319

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
union YYSTYPE
{
#line 85 "sg.y"

  char *string;
  char *tval;
  char *dval;
  char *dvalcron;
  int  *integer;

#line 325 "y.tab.c"

};
typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE yylval;


int yyparse (void);


#endif /* !YY_YY_Y_TAB_H_INCLUDED  */
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_WORD = 3,                       /* WORD  */
  YYSYMBOL_END = 4,                        /* END  */
  YYSYMBOL_START_BRACKET = 5,              /* START_BRACKET  */
  YYSYMBOL_STOP_BRACKET = 6,               /* STOP_BRACKET  */
  YYSYMBOL_WEEKDAY = 7,                    /* WEEKDAY  */
  YYSYMBOL_DESTINATION = 8,                /* DESTINATION  */
  YYSYMBOL_REWRITE = 9,                    /* REWRITE  */
  YYSYMBOL_ACL = 10,                       /* ACL  */
  YYSYMBOL_TIME = 11,                      /* TIME  */
  YYSYMBOL_TVAL = 12,                      /* TVAL  */
  YYSYMBOL_DVAL = 13,                      /* DVAL  */
  YYSYMBOL_DVALCRON = 14,                  /* DVALCRON  */
  YYSYMBOL_SOURCE = 15,                    /* SOURCE  */
  YYSYMBOL_CIDR = 16,                      /* CIDR  */
  YYSYMBOL_IPCLASS = 17,                   /* IPCLASS  */
  YYSYMBOL_CONTINUE = 18,                  /* CONTINUE  */
  YYSYMBOL_IPADDR = 19,                    /* IPADDR  */
  YYSYMBOL_DBHOME = 20,                    /* DBHOME  */
  YYSYMBOL_DOMAINLIST = 21,                /* DOMAINLIST  */
  YYSYMBOL_URLLIST = 22,                   /* URLLIST  */
  YYSYMBOL_EXPRESSIONLIST = 23,            /* EXPRESSIONLIST  */
  YYSYMBOL_IPLIST = 24,                    /* IPLIST  */
  YYSYMBOL_DOMAIN = 25,                    /* DOMAIN  */
  YYSYMBOL_USER = 26,                      /* USER  */
  YYSYMBOL_USERLIST = 27,                  /* USERLIST  */
  YYSYMBOL_USERQUERY = 28,                 /* USERQUERY  */
  YYSYMBOL_LDAPUSERSEARCH = 29,            /* LDAPUSERSEARCH  */
  YYSYMBOL_USERQUOTA = 30,                 /* USERQUOTA  */
  YYSYMBOL_LDAPIPSEARCH = 31,              /* LDAPIPSEARCH  */
  YYSYMBOL_IPQUOTA = 32,                   /* IPQUOTA  */
  YYSYMBOL_IP = 33,                        /* IP  */
  YYSYMBOL_NL = 34,                        /* NL  */
  YYSYMBOL_NUMBER = 35,                    /* NUMBER  */
  YYSYMBOL_PASS = 36,                      /* PASS  */
  YYSYMBOL_REDIRECT = 37,                  /* REDIRECT  */
  YYSYMBOL_LOGDIR = 38,                    /* LOGDIR  */
  YYSYMBOL_SUBST = 39,                     /* SUBST  */
  YYSYMBOL_CHAR = 40,                      /* CHAR  */
  YYSYMBOL_MINUTELY = 41,                  /* MINUTELY  */
  YYSYMBOL_HOURLY = 42,                    /* HOURLY  */
  YYSYMBOL_DAILY = 43,                     /* DAILY  */
  YYSYMBOL_WEEKLY = 44,                    /* WEEKLY  */
  YYSYMBOL_DATE = 45,                      /* DATE  */
  YYSYMBOL_WITHIN = 46,                    /* WITHIN  */
  YYSYMBOL_OUTSIDE = 47,                   /* OUTSIDE  */
  YYSYMBOL_ELSE = 48,                      /* ELSE  */
  YYSYMBOL_LOGFILE = 49,                   /* LOGFILE  */
  YYSYMBOL_SYSLOG = 50,                    /* SYSLOG  */
  YYSYMBOL_ANONYMOUS = 51,                 /* ANONYMOUS  */
  YYSYMBOL_VERBOSE = 52,                   /* VERBOSE  */
  YYSYMBOL_CONTINIOUS = 53,                /* CONTINIOUS  */
  YYSYMBOL_SPORADIC = 54,                  /* SPORADIC  */
  YYSYMBOL_LDAPCACHETIME = 55,             /* LDAPCACHETIME  */
  YYSYMBOL_EXECUSERLIST = 56,              /* EXECUSERLIST  */
  YYSYMBOL_EXECCMD = 57,                   /* EXECCMD  */
  YYSYMBOL_LDAPPROTOVER = 58,              /* LDAPPROTOVER  */
  YYSYMBOL_LDAPBINDDN = 59,                /* LDAPBINDDN  */
  YYSYMBOL_LDAPBINDPASS = 60,              /* LDAPBINDPASS  */
  YYSYMBOL_MYSQLUSERNAME = 61,             /* MYSQLUSERNAME  */
  YYSYMBOL_MYSQLPASSWORD = 62,             /* MYSQLPASSWORD  */
  YYSYMBOL_DATABASE = 63,                  /* DATABASE  */
  YYSYMBOL_QUOTED_STRING = 64,             /* QUOTED_STRING  */
  YYSYMBOL_65_ = 65,                       /* '-'  */
  YYSYMBOL_66_i_ = 66,                     /* 'i'  */
  YYSYMBOL_67_ = 67,                       /* ','  */
  YYSYMBOL_68_ = 68,                       /* '!'  */
  YYSYMBOL_YYACCEPT = 69,                  /* $accept  */
  YYSYMBOL_start = 70,                     /* start  */
  YYSYMBOL_STRING = 71,                    /* STRING  */
  YYSYMBOL_LDAPDNSTR = 72,                 /* LDAPDNSTR  */
  YYSYMBOL_dbhome = 73,                    /* dbhome  */
  YYSYMBOL_sg_syslog = 74,                 /* sg_syslog  */
  YYSYMBOL_logdir = 75,                    /* logdir  */
  YYSYMBOL_ldapcachetime = 76,             /* ldapcachetime  */
  YYSYMBOL_ldapprotover = 77,              /* ldapprotover  */
  YYSYMBOL_ldapbinddn = 78,                /* ldapbinddn  */
  YYSYMBOL_ldapbindpass = 79,              /* ldapbindpass  */
  YYSYMBOL_mysqlusername = 80,             /* mysqlusername  */
  YYSYMBOL_mysqlpassword = 81,             /* mysqlpassword  */
  YYSYMBOL_mysqldb = 82,                   /* mysqldb  */
  YYSYMBOL_start_block = 83,               /* start_block  */
  YYSYMBOL_stop_block = 84,                /* stop_block  */
  YYSYMBOL_destination = 85,               /* destination  */
  YYSYMBOL_destination_block = 86,         /* destination_block  */
  YYSYMBOL_destination_contents = 87,      /* destination_contents  */
  YYSYMBOL_destination_content = 88,       /* destination_content  */
  YYSYMBOL_source = 89,                    /* source  */
  YYSYMBOL_source_block = 90,              /* source_block  */
  YYSYMBOL_source_contents = 91,           /* source_contents  */
  YYSYMBOL_source_content = 92,            /* source_content  */
  YYSYMBOL_domain = 93,                    /* domain  */
  YYSYMBOL_user = 94,                      /* user  */
  YYSYMBOL_acl_block = 95,                 /* acl_block  */
  YYSYMBOL_acl_contents = 96,              /* acl_contents  */
  YYSYMBOL_acl = 97,                       /* acl  */
  YYSYMBOL_acl_content = 98,               /* acl_content  */
  YYSYMBOL_99_1 = 99,                      /* $@1  */
  YYSYMBOL_access_contents = 100,          /* access_contents  */
  YYSYMBOL_access_content = 101,           /* access_content  */
  YYSYMBOL_access_pass = 102,              /* access_pass  */
  YYSYMBOL_cidr = 103,                     /* cidr  */
  YYSYMBOL_ipclass = 104,                  /* ipclass  */
  YYSYMBOL_ips = 105,                      /* ips  */
  YYSYMBOL_ip = 106,                       /* ip  */
  YYSYMBOL_rew = 107,                      /* rew  */
  YYSYMBOL_rew_block = 108,                /* rew_block  */
  YYSYMBOL_rew_contents = 109,             /* rew_contents  */
  YYSYMBOL_rew_content = 110,              /* rew_content  */
  YYSYMBOL_time = 111,                     /* time  */
  YYSYMBOL_time_block = 112,               /* time_block  */
  YYSYMBOL_time_contents = 113,            /* time_contents  */
  YYSYMBOL_time_content = 114,             /* time_content  */
  YYSYMBOL_115_2 = 115,                    /* $@2  */
  YYSYMBOL_116_3 = 116,                    /* $@3  */
  YYSYMBOL_117_4 = 117,                    /* $@4  */
  YYSYMBOL_118_5 = 118,                    /* $@5  */
  YYSYMBOL_119_6 = 119,                    /* $@6  */
  YYSYMBOL_ttime = 120,                    /* ttime  */
  YYSYMBOL_121_7 = 121,                    /* $@7  */
  YYSYMBOL_date = 122,                     /* date  */
  YYSYMBOL_dval = 123,                     /* dval  */
  YYSYMBOL_tval = 124,                     /* tval  */
  YYSYMBOL_dvalcron = 125,                 /* dvalcron  */
  YYSYMBOL_statements = 126,               /* statements  */
  YYSYMBOL_statement = 127                 /* statement  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_uint8 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
#if defined __GNUC__ && ! defined __ICC && 406 <= __GNUC__ * 100 + __GNUC_MINOR__
# if __GNUC__ * 100 + __GNUC_MINOR__ < 407
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")
# else
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# endif
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if !defined yyoverflow

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* !defined yyoverflow */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  3
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   268

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  69
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  59
/* YYNRULES -- Number of rules.  */
#define YYNRULES  156
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  241

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   319


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_int8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    68,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,    67,    65,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,    66,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64
};

#if YYDEBUG
/* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   129,   129,   132,   132,   135,   135,   138,   141,   144,
     147,   150,   153,   156,   159,   162,   165,   169,   173,   176,
     179,   183,   184,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   205,
     208,   211,   212,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   237,   238,   239,   242,   243,   244,
     247,   250,   251,   254,   255,   256,   259,   261,   260,   265,
     266,   269,   270,   271,   272,   273,   274,   275,   276,   279,
     280,   281,   282,   285,   288,   290,   291,   292,   293,   294,
     295,   298,   301,   304,   307,   308,   312,   313,   314,   315,
     316,   317,   318,   319,   323,   326,   329,   330,   334,   335,
     334,   336,   337,   336,   338,   338,   342,   342,   343,   346,
     347,   348,   349,   350,   351,   354,   357,   360,   363,   364,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if YYDEBUG || 0
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "WORD", "END",
  "START_BRACKET", "STOP_BRACKET", "WEEKDAY", "DESTINATION", "REWRITE",
  "ACL", "TIME", "TVAL", "DVAL", "DVALCRON", "SOURCE", "CIDR", "IPCLASS",
  "CONTINUE", "IPADDR", "DBHOME", "DOMAINLIST", "URLLIST",
  "EXPRESSIONLIST", "IPLIST", "DOMAIN", "USER", "USERLIST", "USERQUERY",
  "LDAPUSERSEARCH", "USERQUOTA", "LDAPIPSEARCH", "IPQUOTA", "IP", "NL",
  "NUMBER", "PASS", "REDIRECT", "LOGDIR", "SUBST", "CHAR", "MINUTELY",
  "HOURLY", "DAILY", "WEEKLY", "DATE", "WITHIN", "OUTSIDE", "ELSE",
  "LOGFILE", "SYSLOG", "ANONYMOUS", "VERBOSE", "CONTINIOUS", "SPORADIC",
  "LDAPCACHETIME", "EXECUSERLIST", "EXECCMD", "LDAPPROTOVER", "LDAPBINDDN",
  "LDAPBINDPASS", "MYSQLUSERNAME", "MYSQLPASSWORD", "DATABASE",
  "QUOTED_STRING", "'-'", "'i'", "','", "'!'", "$accept", "start",
  "STRING", "LDAPDNSTR", "dbhome", "sg_syslog", "logdir", "ldapcachetime",
  "ldapprotover", "ldapbinddn", "ldapbindpass", "mysqlusername",
  "mysqlpassword", "mysqldb", "start_block", "stop_block", "destination",
  "destination_block", "destination_contents", "destination_content",
  "source", "source_block", "source_contents", "source_content", "domain",
  "user", "acl_block", "acl_contents", "acl", "acl_content", "$@1",
  "access_contents", "access_content", "access_pass", "cidr", "ipclass",
  "ips", "ip", "rew", "rew_block", "rew_contents", "rew_content", "time",
  "time_block", "time_contents", "time_content", "$@2", "$@3", "$@4",
  "$@5", "$@6", "ttime", "$@7", "date", "dval", "tval", "dvalcron",
  "statements", "statement", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#define YYPACT_NINF (-194)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-127)

#define yytable_value_is_error(Yyn) \
  0

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
static const yytype_int16 yypact[] =
{
    -194,    13,   160,  -194,    12,    30,    35,    40,    42,    18,
    -194,    18,    18,    14,    21,    20,    18,    18,    18,    18,
    -194,  -194,  -194,  -194,  -194,  -194,  -194,  -194,  -194,  -194,
      35,  -194,    35,  -194,  -194,    35,  -194,    35,  -194,  -194,
    -194,  -194,  -194,  -194,  -194,  -194,  -194,  -194,  -194,  -194,
    -194,  -194,  -194,  -194,  -194,  -194,  -194,  -194,  -194,  -194,
    -194,  -194,  -194,  -194,    28,   219,   206,   135,    -3,   -22,
    -194,  -194,    35,  -194,    18,     7,    26,    23,    18,    44,
      50,    29,  -194,  -194,  -194,    18,  -194,  -194,    18,    54,
      18,    24,    57,  -194,    59,   109,    43,    63,  -194,  -194,
    -194,   118,   121,    45,  -194,  -194,   124,  -194,  -194,  -194,
     129,   132,  -194,  -194,  -194,  -194,  -194,  -194,  -194,    18,
    -194,  -194,  -194,  -194,    51,    55,  -194,  -194,     9,    19,
    -194,  -194,  -194,    81,  -194,    33,  -194,  -194,    58,    72,
    -194,  -194,  -194,  -194,    98,    75,  -194,   134,   131,    22,
    -194,  -194,   140,  -194,    18,  -194,    18,  -194,  -194,  -194,
    -194,  -194,    -5,  -194,  -194,   113,    18,  -194,    18,  -194,
      18,  -194,    18,  -194,  -194,  -194,  -194,  -194,  -194,   -10,
     128,   139,  -194,    18,    47,    96,  -194,  -194,  -194,  -194,
    -194,  -194,  -194,  -194,  -194,   133,  -194,  -194,  -194,  -194,
    -194,  -194,   128,   128,  -194,   141,   144,    93,   144,  -194,
       1,  -194,    99,   102,  -194,  -194,  -194,   144,   144,   128,
     128,   128,  -194,  -194,   157,    18,  -194,    18,  -194,    35,
     144,   100,  -194,  -194,  -194,  -194,  -194,   128,   140,  -194,
    -194
};

/* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE does not specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
     138,     0,     2,     1,     0,     0,     0,     0,     0,     0,
     156,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     143,   145,   144,   149,   146,   147,   148,   150,   151,   152,
     140,   142,     0,   141,   153,     0,   154,     0,   155,   139,
      19,   102,    17,    71,   114,    39,     3,     4,     7,     9,
       8,    10,    11,     5,     6,    12,    13,    14,    15,    16,
      21,    41,   104,   116,     0,     0,     0,     0,     0,    73,
      18,    70,     0,    72,     0,     0,     0,     0,     0,     0,
       0,     0,    20,    22,    63,     0,    64,    67,     0,     0,
       0,     0,     0,    95,     0,     0,     0,     0,    40,    42,
     106,     0,     0,     0,   103,   105,   118,   124,   115,   117,
       0,     0,    79,    31,    24,    23,    26,    25,    27,     0,
      29,    30,    32,    33,     0,     0,    38,    55,    43,    44,
      45,    46,    47,     0,    48,    54,    56,    57,     0,     0,
      62,    49,   107,   108,     0,     0,   113,     0,     0,     0,
      74,    75,     0,    28,     0,    34,     0,    35,    66,    65,
      69,    68,     0,   101,   100,    96,     0,    58,     0,    59,
       0,   109,     0,   110,   119,   122,   135,   137,   125,   130,
     134,     0,    89,     0,     0,    76,    80,    36,    37,    53,
      50,    51,    52,    93,    94,     0,    97,    98,    60,    61,
     111,   112,     0,     0,   136,     0,   129,     0,   133,    82,
      81,    83,     0,     0,    88,    77,    99,   120,   123,   132,
       0,     0,    90,    92,     0,     0,    84,     0,    85,     0,
     131,     0,   128,    91,    86,    87,    79,     0,     0,   127,
      78
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -194,  -194,   -11,  -194,  -194,  -194,  -194,  -194,  -194,  -194,
    -194,  -194,  -194,  -194,   -21,   -48,  -194,  -194,  -194,  -194,
    -194,  -194,  -194,  -194,  -194,  -194,  -194,  -194,  -194,  -194,
    -194,   -69,  -194,  -194,  -194,  -194,  -194,   -16,  -194,  -194,
    -194,  -194,  -194,  -194,  -194,  -194,  -194,  -194,  -194,  -194,
    -194,   -55,  -194,  -194,   -20,  -193,  -194,  -194,  -194
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_uint8 yydefgoto[] =
{
       0,     1,    48,    55,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    43,    71,    30,    31,    65,    83,
      32,    33,    66,    99,   128,   129,    34,    64,    72,    73,
     229,   152,   186,   210,   196,   197,   135,   165,    35,    36,
      67,   105,    37,    38,    68,   109,   147,   202,   148,   203,
     149,   206,   220,   178,   179,   207,   180,     2,    39
};

/* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule whose
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
      49,    50,   204,    70,   222,    56,    57,    58,    59,    60,
      46,    61,    46,     3,    62,    40,    63,    82,    98,   104,
     108,    46,    46,    53,   110,   111,    46,   231,   232,    46,
     189,    69,    46,    41,    70,   176,   177,   190,   191,   192,
      42,   106,   107,    44,   239,    45,    46,   122,    46,    51,
      46,   112,   163,   123,    46,   205,    52,   131,    46,   133,
     134,    46,   136,   113,   115,   117,   120,   121,   223,   224,
     126,    47,   114,    47,   127,    46,   158,   130,    46,   132,
     124,   125,    47,    47,    54,   140,   160,    47,   118,   119,
      47,   116,   146,    47,   138,   139,   144,   145,   212,   213,
     164,    46,    46,   154,   185,    46,   156,    47,   153,    47,
     166,    47,   137,   155,   157,    47,   162,   159,   161,    47,
     141,   142,    47,   168,   143,   208,   172,   167,   169,   193,
     194,  -121,   150,   171,   173,   151,    47,   174,   175,    47,
     204,    70,   209,   187,   215,   188,    70,   217,   218,   181,
     170,   225,   163,   227,   176,   198,  -126,   199,   221,   200,
     233,   201,    47,    47,   230,   237,    47,   238,     4,     5,
       6,     7,   211,   214,   100,     8,   182,   183,   195,   216,
       9,   101,   102,     0,   103,   219,     0,     0,     0,   184,
     240,     0,     0,     0,    10,     0,     0,     0,    11,     0,
       0,   226,   228,     0,     0,     0,     0,     0,   236,     0,
      12,     0,    70,     0,   234,    13,   235,     0,    14,    15,
      16,    17,    18,    19,    84,    70,     0,     0,    74,     0,
      85,    86,    87,    88,    89,    90,    91,    92,     0,    93,
      75,    76,    77,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    94,    95,     0,    96,    78,     0,     0,     0,
       0,     0,    97,     0,     0,    79,    80,     0,    81
};

static const yytype_int16 yycheck[] =
{
      11,    12,    12,     6,     3,    16,    17,    18,    19,    30,
       3,    32,     3,     0,    35,     3,    37,    65,    66,    67,
      68,     3,     3,     3,    46,    47,     3,   220,   221,     3,
      35,     3,     3,     3,     6,    13,    14,    42,    43,    44,
       5,    44,    45,     3,   237,     3,     3,     3,     3,    35,
       3,    72,    19,     3,     3,    65,    35,     3,     3,    35,
       3,     3,     3,    74,    75,    76,    77,    78,    67,    68,
      81,    64,    65,    64,    85,     3,    67,    88,     3,    90,
      51,    52,    64,    64,    64,    96,    67,    64,    65,    66,
      64,    65,   103,    64,    51,    52,    51,    52,    51,    52,
      67,     3,     3,    52,   152,     3,    51,    64,   119,    64,
      52,    64,     3,   124,   125,    64,    35,   128,   129,    64,
      57,     3,    64,    51,     3,   180,    51,   138,   139,    16,
      17,     7,     3,   144,   145,     3,    64,     3,     7,    64,
      12,     6,     3,   154,    48,   156,     6,   202,   203,     9,
      52,    52,    19,    51,    13,   166,    12,   168,    65,   170,
       3,   172,    64,    64,   219,    65,    64,   236,     8,     9,
      10,    11,   183,   184,    39,    15,    36,    37,    65,   195,
      20,    46,    47,    -1,    49,   205,    -1,    -1,    -1,    49,
     238,    -1,    -1,    -1,    34,    -1,    -1,    -1,    38,    -1,
      -1,   212,   213,    -1,    -1,    -1,    -1,    -1,   229,    -1,
      50,    -1,     6,    -1,   225,    55,   227,    -1,    58,    59,
      60,    61,    62,    63,    18,     6,    -1,    -1,     9,    -1,
      24,    25,    26,    27,    28,    29,    30,    31,    -1,    33,
      21,    22,    23,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    46,    47,    -1,    49,    37,    -1,    -1,    -1,
      -1,    -1,    56,    -1,    -1,    46,    47,    -1,    49
};

/* YYSTOS[STATE-NUM] -- The symbol kind of the accessing symbol of
   state STATE-NUM.  */
static const yytype_int8 yystos[] =
{
       0,    70,   126,     0,     8,     9,    10,    11,    15,    20,
      34,    38,    50,    55,    58,    59,    60,    61,    62,    63,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      85,    86,    89,    90,    95,   107,   108,   111,   112,   127,
       3,     3,     5,    83,     3,     3,     3,    64,    71,    71,
      71,    35,    35,     3,    64,    72,    71,    71,    71,    71,
      83,    83,    83,    83,    96,    87,    91,   109,   113,     3,
       6,    84,    97,    98,     9,    21,    22,    23,    37,    46,
      47,    49,    84,    88,    18,    24,    25,    26,    27,    28,
      29,    30,    31,    33,    46,    47,    49,    56,    84,    92,
      39,    46,    47,    49,    84,   110,    44,    45,    84,   114,
      46,    47,    83,    71,    65,    71,    65,    71,    65,    66,
      71,    71,     3,     3,    51,    52,    71,    71,    93,    94,
      71,     3,    71,    35,     3,   105,     3,     3,    51,    52,
      71,    57,     3,     3,    51,    52,    71,   115,   117,   119,
       3,     3,   100,    71,    52,    71,    51,    71,    67,    71,
      67,    71,    35,    19,    67,   106,    52,    71,    51,    71,
      52,    71,    51,    71,     3,     7,    13,    14,   122,   123,
     125,     9,    36,    37,    49,    84,   101,    71,    71,    35,
      42,    43,    44,    16,    17,    65,   103,   104,    71,    71,
      71,    71,   116,   118,    12,    65,   120,   124,   120,     3,
     102,    71,    51,    52,    71,    48,   106,   120,   120,   123,
     121,    65,     3,    67,    68,    52,    71,    51,    71,    99,
     120,   124,   124,     3,    71,    71,    83,    65,   100,   124,
      84
};

/* YYR1[RULE-NUM] -- Symbol kind of the left-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr1[] =
{
       0,    69,    70,    71,    71,    72,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    87,    88,    88,    88,    88,    88,    88,    88,
      88,    88,    88,    88,    88,    88,    88,    88,    88,    89,
      90,    91,    91,    92,    92,    92,    92,    92,    92,    92,
      92,    92,    92,    92,    92,    92,    92,    92,    92,    92,
      92,    92,    92,    92,    93,    93,    93,    94,    94,    94,
      95,    96,    96,    97,    97,    97,    98,    99,    98,   100,
     100,   101,   101,   101,   101,   101,   101,   101,   101,   102,
     102,   102,   102,   103,   104,   105,   105,   105,   105,   105,
     105,   106,   107,   108,   109,   109,   110,   110,   110,   110,
     110,   110,   110,   110,   111,   112,   113,   113,   115,   116,
     114,   117,   118,   114,   119,   114,   121,   120,   120,   122,
     122,   122,   122,   122,   122,   123,   124,   125,   126,   126,
     127,   127,   127,   127,   127,   127,   127,   127,   127,   127,
     127,   127,   127,   127,   127,   127,   127
};

/* YYR2[RULE-NUM] -- Number of symbols on the right-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     1,     1,     1,     1,     1,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     1,     1,     2,
       4,     0,     2,     2,     2,     2,     2,     2,     3,     2,
       2,     2,     2,     2,     3,     3,     4,     4,     2,     2,
       4,     0,     2,     2,     2,     2,     2,     2,     2,     2,
       4,     4,     4,     4,     2,     2,     2,     2,     3,     3,
       4,     4,     2,     1,     0,     2,     2,     0,     2,     2,
       4,     0,     2,     1,     3,     3,     4,     0,     9,     0,
       2,     2,     2,     2,     3,     3,     4,     4,     2,     0,
       2,     3,     2,     1,     1,     0,     2,     3,     3,     4,
       2,     1,     2,     4,     0,     2,     1,     2,     2,     3,
       3,     4,     4,     2,     2,     4,     0,     2,     0,     0,
       5,     0,     0,     5,     0,     3,     0,     5,     3,     2,
       1,     4,     3,     2,     1,     1,     1,     1,     0,     2,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYNOMEM         goto yyexhaustedlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)




# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  if (!yyvaluep)
    return;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  yy_symbol_value_print (yyo, yykind, yyvaluep);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp,
                 int yyrule)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)]);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif






/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep)
{
  YY_USE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;




/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */

  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    YYNOMEM;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        YYNOMEM;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          YYNOMEM;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */


  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 7: /* dbhome: DBHOME STRING  */
#line 138 "sg.y"
                         { sgSetting("dbhome",(yyvsp[0].string)); }
#line 1623 "y.tab.c"
    break;

  case 8: /* sg_syslog: SYSLOG STRING  */
#line 141 "sg.y"
                         { sgSetting("syslog",(yyvsp[0].string)); }
#line 1629 "y.tab.c"
    break;

  case 9: /* logdir: LOGDIR STRING  */
#line 144 "sg.y"
                         { sgSetting("logdir",(yyvsp[0].string)); }
#line 1635 "y.tab.c"
    break;

  case 10: /* ldapcachetime: LDAPCACHETIME NUMBER  */
#line 147 "sg.y"
                                    { sgSetting("ldapcachetime",(yyvsp[0].string)); }
#line 1641 "y.tab.c"
    break;

  case 11: /* ldapprotover: LDAPPROTOVER NUMBER  */
#line 150 "sg.y"
                                  { sgSetting("ldapprotover",(yyvsp[0].string)); }
#line 1647 "y.tab.c"
    break;

  case 12: /* ldapbinddn: LDAPBINDDN LDAPDNSTR  */
#line 153 "sg.y"
                                 { sgSetting("ldapbinddn",(yyvsp[0].string)); }
#line 1653 "y.tab.c"
    break;

  case 13: /* ldapbindpass: LDAPBINDPASS STRING  */
#line 156 "sg.y"
                                  { sgSetting("ldapbindpass",(yyvsp[0].string)); }
#line 1659 "y.tab.c"
    break;

  case 14: /* mysqlusername: MYSQLUSERNAME STRING  */
#line 159 "sg.y"
                                    { sgSetting("mysqlusername",(yyvsp[0].string)); }
#line 1665 "y.tab.c"
    break;

  case 15: /* mysqlpassword: MYSQLPASSWORD STRING  */
#line 162 "sg.y"
                                    { sgSetting("mysqlpassword",(yyvsp[0].string)); }
#line 1671 "y.tab.c"
    break;

  case 16: /* mysqldb: DATABASE STRING  */
#line 165 "sg.y"
                               { sgSetting("mysqldb",(yyvsp[0].string)); }
#line 1677 "y.tab.c"
    break;

  case 19: /* destination: DESTINATION WORD  */
#line 176 "sg.y"
                              { sgDest((yyvsp[0].string)); }
#line 1683 "y.tab.c"
    break;

  case 20: /* destination_block: destination start_block destination_contents stop_block  */
#line 180 "sg.y"
                       { sgDestEnd();}
#line 1689 "y.tab.c"
    break;

  case 23: /* destination_content: DOMAINLIST STRING  */
#line 187 "sg.y"
                              { sgDestDomainList((yyvsp[0].string)); }
#line 1695 "y.tab.c"
    break;

  case 24: /* destination_content: DOMAINLIST '-'  */
#line 188 "sg.y"
                             { sgDestDomainList(NULL); }
#line 1701 "y.tab.c"
    break;

  case 25: /* destination_content: URLLIST STRING  */
#line 189 "sg.y"
                             { sgDestUrlList((yyvsp[0].string)); }
#line 1707 "y.tab.c"
    break;

  case 26: /* destination_content: URLLIST '-'  */
#line 190 "sg.y"
                           { sgDestUrlList(NULL); }
#line 1713 "y.tab.c"
    break;

  case 27: /* destination_content: EXPRESSIONLIST '-'  */
#line 191 "sg.y"
                                 { sgDestExpressionList(NULL,NULL); }
#line 1719 "y.tab.c"
    break;

  case 28: /* destination_content: EXPRESSIONLIST 'i' STRING  */
#line 192 "sg.y"
                                        { sgDestExpressionList((yyvsp[0].string),"i"); }
#line 1725 "y.tab.c"
    break;

  case 29: /* destination_content: EXPRESSIONLIST STRING  */
#line 193 "sg.y"
                                    { sgDestExpressionList((yyvsp[0].string),"n"); }
#line 1731 "y.tab.c"
    break;

  case 30: /* destination_content: REDIRECT STRING  */
#line 194 "sg.y"
                              {sgDestRedirect((yyvsp[0].string)); }
#line 1737 "y.tab.c"
    break;

  case 31: /* destination_content: REWRITE STRING  */
#line 195 "sg.y"
                             {sgDestRewrite((yyvsp[0].string)); }
#line 1743 "y.tab.c"
    break;

  case 32: /* destination_content: WITHIN WORD  */
#line 196 "sg.y"
                          { sgDestTime((yyvsp[0].string),WITHIN); }
#line 1749 "y.tab.c"
    break;

  case 33: /* destination_content: OUTSIDE WORD  */
#line 197 "sg.y"
                           { sgDestTime((yyvsp[0].string),OUTSIDE); }
#line 1755 "y.tab.c"
    break;

  case 34: /* destination_content: LOGFILE ANONYMOUS STRING  */
#line 198 "sg.y"
                                       { sgLogFile(SG_BLOCK_DESTINATION,1,0,(yyvsp[0].string)); }
#line 1761 "y.tab.c"
    break;

  case 35: /* destination_content: LOGFILE VERBOSE STRING  */
#line 199 "sg.y"
                                     { sgLogFile(SG_BLOCK_DESTINATION,0,1,(yyvsp[0].string)); }
#line 1767 "y.tab.c"
    break;

  case 36: /* destination_content: LOGFILE ANONYMOUS VERBOSE STRING  */
#line 200 "sg.y"
                                               { sgLogFile(SG_BLOCK_DESTINATION,1,1,(yyvsp[0].string)); }
#line 1773 "y.tab.c"
    break;

  case 37: /* destination_content: LOGFILE VERBOSE ANONYMOUS STRING  */
#line 201 "sg.y"
                                               { sgLogFile(SG_BLOCK_DESTINATION,1,1,(yyvsp[0].string)); }
#line 1779 "y.tab.c"
    break;

  case 38: /* destination_content: LOGFILE STRING  */
#line 202 "sg.y"
                             { sgLogFile(SG_BLOCK_DESTINATION,0,0,(yyvsp[0].string)); }
#line 1785 "y.tab.c"
    break;

  case 39: /* source: SOURCE WORD  */
#line 205 "sg.y"
                         { sgSource((yyvsp[0].string)); }
#line 1791 "y.tab.c"
    break;

  case 40: /* source_block: source start_block source_contents stop_block  */
#line 208 "sg.y"
                                                            {sgSourceEnd();}
#line 1797 "y.tab.c"
    break;

  case 45: /* source_content: USERLIST STRING  */
#line 217 "sg.y"
                                      { sgSourceUserList((yyvsp[0].string)); }
#line 1803 "y.tab.c"
    break;

  case 46: /* source_content: USERQUERY WORD  */
#line 218 "sg.y"
                                     { sgSourceUserQuery((yyvsp[0].string)); }
#line 1809 "y.tab.c"
    break;

  case 47: /* source_content: LDAPUSERSEARCH STRING  */
#line 219 "sg.y"
                                             { sgSourceLdapUserSearch((yyvsp[0].string)); }
#line 1815 "y.tab.c"
    break;

  case 48: /* source_content: LDAPIPSEARCH WORD  */
#line 220 "sg.y"
                                         { sgSourceLdapIpSearch((yyvsp[0].string)); }
#line 1821 "y.tab.c"
    break;

  case 49: /* source_content: EXECUSERLIST EXECCMD  */
#line 221 "sg.y"
                                           { sgSourceExecUserList((yyvsp[0].string)); }
#line 1827 "y.tab.c"
    break;

  case 50: /* source_content: USERQUOTA NUMBER NUMBER HOURLY  */
#line 222 "sg.y"
                                                     { sgSourceUserQuota((yyvsp[-2].string),(yyvsp[-1].string),"3600");}
#line 1833 "y.tab.c"
    break;

  case 51: /* source_content: USERQUOTA NUMBER NUMBER DAILY  */
#line 223 "sg.y"
                                                    { sgSourceUserQuota((yyvsp[-2].string),(yyvsp[-1].string),"86400");}
#line 1839 "y.tab.c"
    break;

  case 52: /* source_content: USERQUOTA NUMBER NUMBER WEEKLY  */
#line 224 "sg.y"
                                                     { sgSourceUserQuota((yyvsp[-2].string),(yyvsp[-1].string),"604800");}
#line 1845 "y.tab.c"
    break;

  case 53: /* source_content: USERQUOTA NUMBER NUMBER NUMBER  */
#line 225 "sg.y"
                                                     { sgSourceUserQuota((yyvsp[-2].string),(yyvsp[-1].string),(yyvsp[0].string));}
#line 1851 "y.tab.c"
    break;

  case 55: /* source_content: IPLIST STRING  */
#line 227 "sg.y"
                                    { sgSourceIpList((yyvsp[0].string)); }
#line 1857 "y.tab.c"
    break;

  case 56: /* source_content: WITHIN WORD  */
#line 228 "sg.y"
                                  { sgSourceTime((yyvsp[0].string),WITHIN); }
#line 1863 "y.tab.c"
    break;

  case 57: /* source_content: OUTSIDE WORD  */
#line 229 "sg.y"
                                   { sgSourceTime((yyvsp[0].string),OUTSIDE); }
#line 1869 "y.tab.c"
    break;

  case 58: /* source_content: LOGFILE ANONYMOUS STRING  */
#line 230 "sg.y"
                                               {sgLogFile(SG_BLOCK_SOURCE,1,0,(yyvsp[0].string));}
#line 1875 "y.tab.c"
    break;

  case 59: /* source_content: LOGFILE VERBOSE STRING  */
#line 231 "sg.y"
                                             {sgLogFile(SG_BLOCK_SOURCE,0,1,(yyvsp[0].string));}
#line 1881 "y.tab.c"
    break;

  case 60: /* source_content: LOGFILE ANONYMOUS VERBOSE STRING  */
#line 232 "sg.y"
                                                       {sgLogFile(SG_BLOCK_SOURCE,1,1,(yyvsp[0].string));}
#line 1887 "y.tab.c"
    break;

  case 61: /* source_content: LOGFILE VERBOSE ANONYMOUS STRING  */
#line 233 "sg.y"
                                                       {sgLogFile(SG_BLOCK_SOURCE,1,1,(yyvsp[0].string));}
#line 1893 "y.tab.c"
    break;

  case 62: /* source_content: LOGFILE STRING  */
#line 234 "sg.y"
                                     { sgLogFile(SG_BLOCK_SOURCE,0,0,(yyvsp[0].string)); }
#line 1899 "y.tab.c"
    break;

  case 63: /* source_content: CONTINUE  */
#line 235 "sg.y"
                               { lastSource->cont_search = 1; }
#line 1905 "y.tab.c"
    break;

  case 65: /* domain: domain STRING  */
#line 238 "sg.y"
                                    { sgSourceDomain((yyvsp[0].string)); }
#line 1911 "y.tab.c"
    break;

  case 68: /* user: user STRING  */
#line 243 "sg.y"
                                  { sgSourceUser((yyvsp[0].string)); }
#line 1917 "y.tab.c"
    break;

  case 73: /* acl: WORD  */
#line 254 "sg.y"
                     {sgAcl((yyvsp[0].string),NULL,0);}
#line 1923 "y.tab.c"
    break;

  case 74: /* acl: WORD WITHIN WORD  */
#line 255 "sg.y"
                                  {sgAcl((yyvsp[-2].string),(yyvsp[0].string),WITHIN);}
#line 1929 "y.tab.c"
    break;

  case 75: /* acl: WORD OUTSIDE WORD  */
#line 256 "sg.y"
                                   { sgAcl((yyvsp[-2].string),(yyvsp[0].string),OUTSIDE); }
#line 1935 "y.tab.c"
    break;

  case 77: /* $@1: %empty  */
#line 261 "sg.y"
                   {sgAcl(NULL,NULL,ELSE);}
#line 1941 "y.tab.c"
    break;

  case 81: /* access_content: PASS access_pass  */
#line 269 "sg.y"
                                    { }
#line 1947 "y.tab.c"
    break;

  case 82: /* access_content: REWRITE WORD  */
#line 270 "sg.y"
                                 { sgAclSetValue("rewrite",(yyvsp[0].string),0); }
#line 1953 "y.tab.c"
    break;

  case 83: /* access_content: REDIRECT STRING  */
#line 271 "sg.y"
                                    { sgAclSetValue("redirect",(yyvsp[0].string),0); }
#line 1959 "y.tab.c"
    break;

  case 84: /* access_content: LOGFILE ANONYMOUS STRING  */
#line 272 "sg.y"
                                             {sgLogFile(SG_BLOCK_ACL,1,0,(yyvsp[0].string));}
#line 1965 "y.tab.c"
    break;

  case 85: /* access_content: LOGFILE VERBOSE STRING  */
#line 273 "sg.y"
                                           {sgLogFile(SG_BLOCK_ACL,0,1,(yyvsp[0].string));}
#line 1971 "y.tab.c"
    break;

  case 86: /* access_content: LOGFILE ANONYMOUS VERBOSE STRING  */
#line 274 "sg.y"
                                                     {sgLogFile(SG_BLOCK_ACL,1,1,(yyvsp[0].string));}
#line 1977 "y.tab.c"
    break;

  case 87: /* access_content: LOGFILE VERBOSE ANONYMOUS STRING  */
#line 275 "sg.y"
                                                     {sgLogFile(SG_BLOCK_ACL,1,1,(yyvsp[0].string));}
#line 1983 "y.tab.c"
    break;

  case 88: /* access_content: LOGFILE STRING  */
#line 276 "sg.y"
                                   { sgLogFile(SG_BLOCK_ACL,0,0,(yyvsp[0].string)); }
#line 1989 "y.tab.c"
    break;

  case 90: /* access_pass: access_pass WORD  */
#line 280 "sg.y"
                                     { sgAclSetValue("pass",(yyvsp[0].string),1);}
#line 1995 "y.tab.c"
    break;

  case 91: /* access_pass: access_pass '!' WORD  */
#line 281 "sg.y"
                                         { sgAclSetValue("pass",(yyvsp[0].string),0);}
#line 2001 "y.tab.c"
    break;

  case 93: /* cidr: CIDR  */
#line 285 "sg.y"
                       { sgIp((yyvsp[0].string)); }
#line 2007 "y.tab.c"
    break;

  case 94: /* ipclass: IPCLASS  */
#line 288 "sg.y"
                          { sgIp((yyvsp[0].string)); }
#line 2013 "y.tab.c"
    break;

  case 96: /* ips: ips ip  */
#line 291 "sg.y"
                             { sgIp("255.255.255.255") ; sgSetIpType(SG_IPTYPE_HOST,NULL,0); }
#line 2019 "y.tab.c"
    break;

  case 97: /* ips: ips ip cidr  */
#line 292 "sg.y"
                                  { sgSetIpType(SG_IPTYPE_CIDR,NULL,0); }
#line 2025 "y.tab.c"
    break;

  case 98: /* ips: ips ip ipclass  */
#line 293 "sg.y"
                                     { sgSetIpType(SG_IPTYPE_CLASS,NULL,0); }
#line 2031 "y.tab.c"
    break;

  case 99: /* ips: ips ip '-' ip  */
#line 294 "sg.y"
                                     { sgSetIpType(SG_IPTYPE_RANGE,NULL,0); }
#line 2037 "y.tab.c"
    break;

  case 101: /* ip: IPADDR  */
#line 298 "sg.y"
            { sgIp((yyvsp[0].string));}
#line 2043 "y.tab.c"
    break;

  case 102: /* rew: REWRITE WORD  */
#line 301 "sg.y"
                        { sgRewrite((yyvsp[0].string)); }
#line 2049 "y.tab.c"
    break;

  case 106: /* rew_content: SUBST  */
#line 312 "sg.y"
                       { sgRewriteSubstitute((yyvsp[0].string)); }
#line 2055 "y.tab.c"
    break;

  case 107: /* rew_content: WITHIN WORD  */
#line 313 "sg.y"
                              { sgRewriteTime((yyvsp[0].string),WITHIN); }
#line 2061 "y.tab.c"
    break;

  case 108: /* rew_content: OUTSIDE WORD  */
#line 314 "sg.y"
                               { sgRewriteTime((yyvsp[0].string),OUTSIDE); }
#line 2067 "y.tab.c"
    break;

  case 109: /* rew_content: LOGFILE ANONYMOUS STRING  */
#line 315 "sg.y"
                                           { sgLogFile(SG_BLOCK_REWRITE,1,0,(yyvsp[0].string)); }
#line 2073 "y.tab.c"
    break;

  case 110: /* rew_content: LOGFILE VERBOSE STRING  */
#line 316 "sg.y"
                                         { sgLogFile(SG_BLOCK_REWRITE,0,1,(yyvsp[0].string)); }
#line 2079 "y.tab.c"
    break;

  case 111: /* rew_content: LOGFILE ANONYMOUS VERBOSE STRING  */
#line 317 "sg.y"
                                                   { sgLogFile(SG_BLOCK_REWRITE,1,1,(yyvsp[0].string)); }
#line 2085 "y.tab.c"
    break;

  case 112: /* rew_content: LOGFILE VERBOSE ANONYMOUS STRING  */
#line 318 "sg.y"
                                                   { sgLogFile(SG_BLOCK_REWRITE,1,1,(yyvsp[0].string)); }
#line 2091 "y.tab.c"
    break;

  case 113: /* rew_content: LOGFILE STRING  */
#line 319 "sg.y"
                                 { sgLogFile(SG_BLOCK_REWRITE,0,0,(yyvsp[0].string)); }
#line 2097 "y.tab.c"
    break;

  case 114: /* time: TIME WORD  */
#line 323 "sg.y"
                      { sgTime((yyvsp[0].string)); }
#line 2103 "y.tab.c"
    break;

  case 118: /* $@2: %empty  */
#line 334 "sg.y"
                        {sgTimeElementInit();}
#line 2109 "y.tab.c"
    break;

  case 119: /* $@3: %empty  */
#line 335 "sg.y"
                         {sgTimeElementAdd((yyvsp[0].string),T_WEEKLY);}
#line 2115 "y.tab.c"
    break;

  case 121: /* $@4: %empty  */
#line 336 "sg.y"
                          {sgTimeElementInit();}
#line 2121 "y.tab.c"
    break;

  case 122: /* $@5: %empty  */
#line 337 "sg.y"
                         {sgTimeElementAdd((yyvsp[0].string),T_WEEKDAY);}
#line 2127 "y.tab.c"
    break;

  case 124: /* $@6: %empty  */
#line 338 "sg.y"
                        {sgTimeElementInit();}
#line 2133 "y.tab.c"
    break;

  case 125: /* time_content: DATE $@6 date  */
#line 339 "sg.y"
                         {sgTimeElementEnd();}
#line 2139 "y.tab.c"
    break;

  case 126: /* $@7: %empty  */
#line 342 "sg.y"
                       { sgTimeElementClone(); }
#line 2145 "y.tab.c"
    break;

  case 135: /* dval: DVAL  */
#line 354 "sg.y"
                      { sgTimeElementAdd((yyvsp[0].string),T_DVAL);}
#line 2151 "y.tab.c"
    break;

  case 136: /* tval: TVAL  */
#line 357 "sg.y"
                      { sgTimeElementAdd((yyvsp[0].tval),T_TVAL);}
#line 2157 "y.tab.c"
    break;

  case 137: /* dvalcron: DVALCRON  */
#line 360 "sg.y"
                          { sgTimeElementAdd((yyvsp[0].string),T_DVALCRON);}
#line 2163 "y.tab.c"
    break;


#line 2167 "y.tab.c"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      yyerror (YY_("syntax error"));
    }

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;
  ++yynerrs;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturnlab;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturnlab;


/*-----------------------------------------------------------.
| yyexhaustedlab -- YYNOMEM (memory exhaustion) comes here.  |
`-----------------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturnlab;


/*----------------------------------------------------------.
| yyreturnlab -- parsing is finished, clean up and return.  |
`----------------------------------------------------------*/
yyreturnlab:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif

  return yyresult;
}

#line 387 "sg.y"


#if __STDC__
void sgReadConfig (char *file)
#else
void sgReadConfig (file)
     char *file;
#endif
{
  char *defaultFile=DEFAULT_CONFIGFILE;
  lineno = 1;
  configFile = file;
  if(configFile == NULL)
    configFile = defaultFile;
  yyin = fopen(configFile,"r");
  if(yyin == NULL) 
    sgLogFatal("%s: FATAL: can't open configfile  %s",progname, configFile);
  (void)yyparse();
  if(defaultAcl == NULL)
    sgLogFatal("%s: FATAL: default acl not defined in configfile  %s",
	progname, configFile);
  fclose(yyin);
}

#if __STDC__
struct UserInfo *setuserinfo()
#else
struct UserInfo *setuserinfo()
#endif
{
  static struct UserInfo uq;
  uq.status = 0; 
  uq.time = 0; 
  uq.consumed = 0; 
  uq.last = 0; 
#ifdef HAVE_LIBLDAP
  uq.ldapuser = 0;
  uq.found = 0;
  uq.cachetime = 0;
#endif
  return &uq;
}


/*
  
  Logfile functions

*/

#if __STDC__
void sgLogFile (int block, int anonymous, int verbose, char *file)
#else
void sgLogFile (block, anonymous, verbose, file)
     int block;
     int anonymous;
     int verbose;
     char *file;
#endif
{
  void **v;
  char *name;
  struct LogFile *p;
  switch(block){
  case(SG_BLOCK_DESTINATION):
    v = (void **) &lastDest->logfile;
    name = lastDest->name;
    break;
  case(SG_BLOCK_SOURCE):
    v = (void **) &lastSource->logfile;
    name = lastSource->name;
    break;
  case(SG_BLOCK_REWRITE):
    v = (void **) &lastRewrite->logfile;
    name = lastRewrite->name;
    break;
  case(SG_BLOCK_ACL):
    v = (void **) &lastAcl->logfile;
    name = lastAcl->name;
    if(strcmp(name,"default")){
      sgLogError("logfile not allowed in acl other than default");
    }
    break;
  default:
    return;
  }
  if(*v == NULL){
    p = (struct LogFile *) sgCalloc(1,sizeof(struct LogFile));
    p->stat = sgLogFileStat(file);
    p->parent_name = name;
    p->parent_type = block;
    p->anonymous = anonymous;
    p->verbose = verbose;
    *v = p;
  } else {
    sgLogError("%s: redefine of logfile %s in line %d",
		    progname,file,lineno);
    return;
  }
}

#if __STDC__
struct LogFileStat *sgLogFileStat(char *file)
#else
struct LogFileStat *sgLogFileStat(file)
     char *file;
#endif
{
  struct LogFileStat *sg;
  struct stat s;
  char buf[MAX_BUF];
  FILE *fd;
  strncpy(buf,file,MAX_BUF);
  if(*file != '/'){
    if(globalLogDir == NULL)
      strncpy(buf,DEFAULT_LOGDIR,MAX_BUF);
    else
      strncpy(buf,globalLogDir,MAX_BUF);
    strcat(buf,"/");
    strcat(buf,file);
  }
  if((fd = fopen(buf, "a")) == NULL){
    sgLogError("%s: can't write to logfile %s",progname,buf);
    return NULL;
  }
  if(stat(buf,&s) != 0){
    sgLogError("%s: can't stat logfile %s",progname,buf);
    return NULL;
  }
  if(LogFileStat == NULL){
    sg = (struct LogFileStat *) sgCalloc(1,sizeof(struct LogFileStat));
    sg->name = sgMalloc(strlen(buf) + 1);
    strcpy(sg->name,buf);
    sg->st_ino = s.st_ino;
    sg->st_dev = s.st_dev;
    sg->fd = fd;
    sg->next = NULL;
    LogFileStat = sg;
    lastLogFileStat = sg;
  } else {
    for(sg = LogFileStat; sg != NULL; sg = sg->next){
      if(sg->st_ino == s.st_ino && sg->st_dev == s.st_dev){
	fclose(fd);
	return sg;
      }
    }
    sg = (struct LogFileStat *) sgCalloc(1,sizeof(struct LogFileStat));
    sg->name = sgMalloc(strlen(buf) + 1);
    strcpy(sg->name,buf);
    sg->st_ino = s.st_ino;
    sg->st_dev = s.st_dev;
    sg->fd = fd;
    sg->next = NULL;
    lastLogFileStat->next = sg;
    lastLogFileStat = sg;
  }
  return lastLogFileStat;
}
/*
  
  Source functions

*/

#if __STDC__
void sgSource(char *source)
#else
void sgSource(source)
     char *source;
#endif
{
  struct Source *sp;
  if(Source != NULL){
    if((struct Source *) sgSourceFindName(source) != NULL)
      sgLogFatal("%s: source %s is defined in configfile %s",
		      progname,source, configFile);
  }
  sp = (struct Source *)sgCalloc(1,sizeof(struct Source));
  sp->ip=NULL;
  sp->userDb=NULL;
  sp->domainDb=NULL;
  sp->active = 1;
  sp->within = 0;
  sp->cont_search = 0;
  sp->time = NULL;
  sp->userquota.seconds = 0;
  sp->userquota.renew = 0;
  sp->userquota.sporadic = 0;
#ifdef HAVE_LIBLDAP
  sp->ipDb = NULL;
  sp->ipquota.seconds = 0;
  sp->ipquota.renew = 0;
  sp->ipquota.sporadic = 0;
#endif
  sp->next=NULL;
  sp->logfile = NULL;
  sp->name = (char  *) sgCalloc(1,strlen(source) + 1);
  strcpy(sp->name,source);

  if(Source == NULL){
    Source = sp;
    lastSource = sp;
  } else {
    lastSource->next = sp;
    lastSource = sp;
  }
}

#ifdef HAVE_LIBLDAP
void sgSourceEnd()
{
 struct Source *s;
 s = lastSource;
 if(s->ip == NULL && s->domainDb == NULL && s->userDb == NULL
       && s->ipDb == NULL
       && s->ldapuserurlcount == 0 && s->ldapipurlcount == 0 ){
   sgLogError("sourceblock %s missing active content, set inactive",s->name);
   s->time = NULL;
   s->active = 0;
 }
}
#else
void sgSourceEnd()
{
 struct Source *s;
 s = lastSource;
 if(s->ip == NULL && s->domainDb == NULL && s->userDb == NULL){
   sgLogError("sourceblock %s missing active content, set inactive",s->name);
   s->time = NULL;
   s->active = 0;
 }
}
#endif

#if __STDC__
void sgSourceUser(char *user)
#else
void sgSourceUser(user)
     char *user;
#endif
{
  struct Source *sp;
  char *lc;
  sp = lastSource;
  if(sp->userDb == NULL){
    sp->userDb = (struct sgDb *) sgCalloc(1,sizeof(struct sgDb));
    sp->userDb->type=SGDBTYPE_USERLIST;
    sgDbInit(sp->userDb,NULL);
  }
  for(lc=user; *lc != '\0'; lc++) /* convert username to lowercase chars */
    *lc = tolower(*lc);
  sgDbUpdate(sp->userDb, user, (char *) setuserinfo(),
            sizeof(struct UserInfo));
// DEBUG
  sgLogError("Added User: %s", user);
}

#if __STDC__
void sgSourceUserList(char *file)
#else
void sgSourceUserList(file)
     char *file;
#endif
{
  char *dbhome = NULL, *f;
  FILE *fd;
  char line[MAX_BUF];
  char *p,*c,*s,*lc;
  int l=0;
  struct Source *sp;
  sp = lastSource;
  if(sp->userDb == NULL){
    sp->userDb = (struct sgDb *) sgCalloc(1,sizeof(struct sgDb));
    sp->userDb->type=SGDBTYPE_USERLIST;
    sgDbInit(sp->userDb,NULL);
  }
  dbhome = sgSettingGetValue("dbhome");
  if(dbhome == NULL)
    dbhome = DEFAULT_DBHOME;
  if (file[0] == '/') {
    f = strdup(file);
  } else {
    f = (char  *) sgCalloc(1,strlen(dbhome) + strlen(file) + 5);
    strcpy(f,dbhome);
    strcat(f,"/");
    strcat(f,file);
  }
  if((fd = fopen(f,"r")) == NULL){
    sgLogError("%s: can't open userlist %s: %s",progname, f,strerror(errno));
    return;
  }
  while(fgets(line,sizeof(line),fd) != NULL){
    l++;
    if(*line == '#')
      continue;
    p = strchr(line,'\n');
    if(p != NULL && p != line){
      if(*(p - 1) == '\r') /* removing ^M  */
	p--;
      *p = '\0';
    }
    c = strchr(line,'#');
    p = strtok(line," \t,");
    if((s = strchr(line,':')) != NULL){
      *s = '\0';
      for(lc=line; *lc != '\0'; lc++) /* convert username to lowercase chars */
	*lc = tolower(*lc);
      sgDbUpdate(sp->userDb, line, (char *) setuserinfo(),
                sizeof(struct UserInfo));
    } else {
      do {
	if(c != NULL && p >= c) /*find the comment */
	  break;
	for(lc=p; *lc != '\0'; lc++) /* convert username to lowercase chars */
	  *lc = tolower(*lc);
       sgDbUpdate(sp->userDb, p, (char *) setuserinfo(),
                  sizeof(struct UserInfo));
// DEBUG
        sgLogError("Added UserList source: %s", p);
      } while((p=strtok(NULL," \t,")) != NULL);
    }
  }
  fclose(fd);
}


/* MySQLsupport */
#ifdef HAVE_MYSQL
#if __STDC__
void sgSourceUserQuery(char *query)
#else
void sgSourceUserQuery(query)
     char *query;
#endif
{
  char *dbhome = NULL, *f;
  MYSQL *conn;
  MYSQL_RES *res;
  MYSQL_ROW row;
  char line[MAX_BUF];
  char *my_query, *my_user, *my_pass, *my_db;
  char *str=";";
  int l=0;
  struct Source *sp;
  sp = lastSource;
  if(sp->userDb == NULL){
    sp->userDb = (struct sgDb *) sgCalloc(1,sizeof(struct sgDb));
    sp->userDb->type=SGDBTYPE_USERLIST;
    sgDbInit(sp->userDb,NULL);
  }
  dbhome = sgSettingGetValue("dbhome");
  my_user = sgSettingGetValue("mysqlusername");
  my_pass = sgSettingGetValue("mysqlpassword");
  my_db = sgSettingGetValue("mysqldb");
  if(dbhome == NULL) {
    dbhome = DEFAULT_DBHOME;
  }
  if( !(conn = mysql_init(0)) ) {
    /* nolog option set: sgLogError("%s: can't open userquery: mysql init",progname); */
    return;
  }
  if( ! mysql_real_connect(conn, "localhost", my_user, my_pass, my_db,
      0,NULL,0) ) {
    /* nolog option set: sgLogError("%s: can't open userquery: mysql connect",progname); */
    return;
  }
  my_query=(char *)calloc(strlen(query) + strlen(str) + 1,sizeof(char));
  strcat(my_query, query);
  strcat(my_query, str);
  /* DEBUG:   sgLogError("%s: TEST: MySQL Query %s",progname,my_query);  */
  if( mysql_query(conn, my_query) ) {
    /* nolog option set: sgLogError("%s: can't open userquery: mysql query",progname); */
    return;
  }
  res = mysql_use_result(conn);
  while( row = mysql_fetch_row(res) ) {
    strncpy(line, row[0], sizeof(line)-1);
    l++;
    sgDbUpdate(sp->userDb, line, (char *) setuserinfo(), sizeof(struct UserInfo));
    /* nolog option set: sgLogError("Added MySQL source: %s", line); */
  }
  mysql_free_result(res);
  mysql_close(conn);
 }
#endif


/* LDAP Support */
#ifdef HAVE_LIBLDAP
#if __STDC__
void sgSourceLdapUserSearch(char *url)
#else
void sgSourceLdapUserSearch(url)
     char *url;
#endif
{
  struct Source *sp;
  sp = lastSource;

/*  DEBUG
  sgLogError("sgSourceLdapUserSearch called with: %s", url);
*/

  if(!ldap_is_ldap_url(url)) {
    /* nolog option set: sgLogError("%s: can't parse LDAP url %s",progname, url);  */
    return;
  }

  /* looks ok, add the url to the source object url array */
  sp->ldapuserurls = (char**) sgRealloc(sp->ldapuserurls,
                              sizeof(char*) * (sp->ldapuserurlcount+1));
  sp->ldapuserurls[sp->ldapuserurlcount] = (char*) sgMalloc(strlen(url) + 1);
  strcpy(sp->ldapuserurls[sp->ldapuserurlcount], url);
  sp->ldapuserurlcount++;

  /* create a userDb if it doesn't exist, since we'll need it later
   * for caching */
  if(sp->userDb == NULL){
    sp->userDb = (struct sgDb *) sgCalloc(1,sizeof(struct sgDb));
    sp->userDb->type=SGDBTYPE_USERLIST;
    sgDbInit(sp->userDb,NULL);
  }
}
#if __STDC__
void sgSourceLdapIpSearch(char *url)
#else
void sgSourceLdapIpSearch(url)
     char *url;
#endif
{
  struct Source *sp;
  sp = lastSource;

   /* nolog option set: sgLogError("DEBUG: sgSourceLdapIpSearch called with: %s", url); */

  if(!ldap_is_ldap_url(url)) {
    sgLogError("%s: can't parse LDAP url %s",progname, url);
    return;
  }

  /* looks ok, add the url to the source object url array */
  sp->ldapipurls = (char**) sgRealloc(sp->ldapipurls,
                                    sizeof(char*) * (sp->ldapipurlcount+1));
  sp->ldapipurls[sp->ldapipurlcount] = (char*) sgMalloc(strlen(url) + 1);
  strcpy(sp->ldapipurls[sp->ldapipurlcount], url);
  sp->ldapipurlcount++;

  /* create a ipDb if it doesn't exist, since we'll need it later
   * for caching */
  if(sp->ipDb == NULL){
    sp->ipDb = (struct sgDb *) sgCalloc(1,sizeof(struct sgDb));
    sp->ipDb->type=SGDBTYPE_USERLIST;
    sgDbInit(sp->ipDb,NULL);
  }
}
#endif

#if __STDC__
void sgSourceExecUserList(char *cmd)
#else
void sgSourceExecUserList(cmd)
     char *cmd;
#endif
{
  FILE *pInput;
  char buffer[100];
  struct Source *sp;
  char *lc;
  sp = lastSource;
  if(sp->userDb == NULL){
    sp->userDb = (struct sgDb *) sgCalloc(1,sizeof(struct sgDb));
    sp->userDb->type=SGDBTYPE_USERLIST;
    sgDbInit(sp->userDb,NULL);
  }

/*  DEBUG
  sgLogError("sgSourceExecUserList called with: %s", cmd);
*/

  pInput = popen(cmd, "r");
  if(pInput == NULL) {
    sgLogError("%s: Unable to run execuserlist command: %s", progname, cmd);
    return;
  }

  while(fgets(buffer, sizeof(buffer), pInput) != NULL) {
    char *sc;
    /* skip leading whitespace */
    for(sc=buffer; *sc != '\0' && isspace(*sc); sc++)
    ;
    /* convert username to lowercase */
    for(lc=sc; *lc != '\0'; lc++)
      *lc = tolower(*lc);
    /* remove newline and trailing whitespace */
    while(lc>=sc && (*lc=='\0' || isspace(*lc)))
      *lc-- = '\0';
    if(lc >= sc) {
      sgDbUpdate(sp->userDb, sc, (char *) setuserinfo(),
                 sizeof(struct UserInfo));
      /* nolog option set: sgLogError("Added exec source: %s", sc); */
    }
  }

  pclose(pInput);
}



#if __STDC__
void sgSourceUserQuota(char *seconds, char *sporadic, char *renew)
#else
void sgSourceUserQuota(seconds, sporadic, renew)
     char *seconds;
     char *sporadic;
     char *renew;
#endif
{
  int s;
  struct UserQuota *uq;
  struct Source *sp;
  sp = lastSource;
  uq = &sp->userquota;
  s = atoi(seconds);
  if(s <= 0)
    sgLogError("Userquota seconds sporadic hourly|daily|weekly");
  uq->seconds = s; 
  s = atoi(sporadic);
  if(s <= 0)
    sgLogError("Userquota seconds sporadic hourly|daily|weekly");
  uq->sporadic = s; 
  s = atoi(renew);
  if(s <= 0)
    sgLogError("Userquota seconds sporadic hourly|daily|weekly");
  uq->renew = s;
}


#if __STDC__
void sgSourceDomain(char *domain)
#else
void sgSourceDomain(domain)
     char *domain;
#endif
{
  struct Source *sp;
  sp = lastSource;
  if(sp->domainDb == NULL){
    sp->domainDb = (struct sgDb *) sgCalloc(1,sizeof(struct sgDb));
    sp->domainDb->type=SGDBTYPE_DOMAINLIST;
    sgDbInit(sp->domainDb,NULL);
  }
  sgDbUpdate(sp->domainDb,domain, NULL, 0);
}

#if __STDC__
void sgSourceTime(char *name, int within)
#else
void sgSourceTime(name, within)
     char *name;
     int within;
#endif
{
  struct Time *time = NULL;
  struct Source *sp;
  sp = lastSource;
  if((time = sgTimeFindName(name)) == NULL){
    sgLogFatal("%s: FATAL: Time %s is not defined in configfile %s",
		    progname,name, configFile);
  }
  sp->within = within;
  sp->time = time;
}

#if __STDC__
struct Source *sgSourceFindName(char *name)
#else
struct Source *sgSourceFindName(name)
     char *name;
#endif
{
  struct Source *p;
  for(p=Source; p != NULL; p = p->next){
    if(!strcmp(name,p->name))
      return p;
  }
  return NULL;
}

#if __STDC__
void sgSourceIpList(char *file)
#else
void sgSourceIpList(file)
     char *file;
#endif
{
  char *dbhome = NULL, *f;
  FILE *fd;
  char line[MAX_BUF];
  char *p,*c,*cidr;
  int i,l=0;
  dbhome = sgSettingGetValue("dbhome");
  if(dbhome == NULL)
    dbhome = DEFAULT_DBHOME;
  if (file[0] == '/') {
    f = strdup(file);
  } else {
    f = (char  *) sgCalloc(1,strlen(dbhome) + strlen(file) + 5);
    strcpy(f,dbhome);
    strcat(f,"/");
    strcat(f,file);
  }
  if((fd = fopen(f,"r")) == NULL){
    sgLogError("%s: can't open iplist %s: %s",progname, f,strerror(errno));
    return;
  }
  sgLogError("init iplist %s",f);
  while(fgets(line,sizeof(line),fd) != NULL){
    l++;
    if(*line == '#')
      continue;
    p = strchr(line,'\n');
    if(p != NULL && p != line){
      if(*(p - 1) == '\r') /* removing ^M  */
	p--;
      *p = '\0';
    }
    c = strchr(line,'#');
    p = strtok(line," \t,");
    do {
      if(c != NULL && p >= c) /*find the comment */
	break;
      i=strspn(p,".0123456789/-");
      if(i == 0)
	break;
      *(p + i ) = '\0';
      if((cidr = strchr(p,'/')) != NULL){
	*cidr = '\0';
	cidr++;
	sgIp(p);
	sgIp(cidr);
	if(strchr(cidr,'.') == NULL)
	  sgSetIpType(SG_IPTYPE_CIDR,f,l);
	else 
	  sgSetIpType(SG_IPTYPE_CLASS,f,l);
      } else if((cidr = strchr(p,'-')) != NULL) {
	*cidr = '\0';
	cidr++;
	sgIp(p);
	sgIp(cidr);
	sgSetIpType(SG_IPTYPE_RANGE,f,l);
      } else {
	sgIp(p);
	sgIp(strdup("255.255.255.255"));
	sgSetIpType(SG_IPTYPE_HOST,f,l);
      }
    } while((p=strtok(NULL," \t,")) != NULL);
  }
  fclose(fd);
}

/*
  

 */

#if __STDC__
struct Source *sgFindSource (struct Source *bsrc, 
			     char *net, char *ident, char *domain)
#else
struct Source *sgFindSource (bsrc, net, ident, domain)
     struct Source *bsrc;
     char *net;
     char *ident;
     char *domain;
#endif
{
/* DEBUG
  sgLogError("DEBUG: sgfindsource  called with: %s", net);
*/
  struct Source *s;
  struct Ip *ip;
  int foundip, founduser, founddomain, unblockeduser;
  unsigned long i, octet = 0, *op;
  struct UserInfo *userquota;
  char *dotnet;
#ifdef HAVE_LIBLDAP
  int unblockedip;
  struct IpInfo *ipquota;
#endif
  if(net != NULL){
    dotnet = (char*) sgMalloc(strlen(net) + 1);
    strcpy(dotnet, net);
    op = sgConvDot(net);
    if(op != NULL)
      octet = *op;
  }
  for(s=bsrc; s != NULL; s = s->next){
    foundip = founduser = founddomain = 0;
    unblockeduser = 1;
    if(s->active == 0)
      continue;
    if(s->ip != NULL){
      if(net == NULL)
	foundip = 0;
      else {
	for(ip=s->ip; ip != NULL; ip = ip->next){
	  if(ip->net_is_set == 0)
	    continue;
	  if(ip->type == SG_IPTYPE_RANGE){
	    if(octet >= ip->net && octet <= ip->mask){
	      foundip = 1;
	      break;
	    }
	  } else { /* CIDR or HOST */
	    i = octet & ip->mask;
	    if(i == ip->net){
	      foundip = 1;
	      break;
	    }
	  }
	}
      }
    } else
#ifdef HAVE_LIBLDAP 
// debut ip
      if( s->ipDb != NULL){
      if(dotnet == NULL)
       foundip = 0;
      else {
//        rfc1738_unescape(dotnet);
        if(sgFindIp(s, dotnet, &ipquota)) {
         foundip = 1;
         unblockedip = 1;
         if(s->ipquota.seconds != 0){
            struct IpInfo uq;
           time_t t = time(NULL) + globalDebugTimeDelta;
           sgLogError("status %d time %d lasttime %d consumed %d", ipquota->status, ipquota->time, ipquota->last, ipquota->consumed);
           sgLogError("renew %d seconds %d", s->ipquota.renew, s->ipquota.seconds);
           if(ipquota->status == 0){ //first time
             ipquota->status = 1;
             ipquota->time = t;
             ipquota->last = t;
             sgLogError("ip %s first time %d", dotnet, ipquota->time);
           } else if(ipquota->status == 1){
             sgLogError("ip %s other time %d %d",dotnet,ipquota->time,t);
             if(s->ipquota.sporadic > 0){
               if(t - ipquota->last  < s->ipquota.sporadic){
                 ipquota->consumed += t - ipquota->last;
                 ipquota->time = t;
               }
               if(ipquota->consumed > s->ipquota.seconds){
                 ipquota->status = 2; // block this ip, time is up
                 unblockedip = 0;
               }
               ipquota->last = t;
               sgLogError("ip %s consumed %d %d",dotnet,ipquota->consumed, ipquota->last);
             } else if(ipquota->time + s->ipquota.seconds < t){
               sgLogError("time is up ip %s blocket", net);
               ipquota->status = 2; // block this ip, time is up
               unblockedip = 0;
             } 
           } else {
             sgLogError("ip %s blocket %d %d %d %d", dotnet, ipquota->status, ipquota->time, t, (ipquota->time + s->ipquota.renew) - t);
             if(ipquota->time + s->ipquota.renew < t){ // new chance
               sgLogError("ip %s new chance", net);
               unblockedip = 1;
               ipquota->status = 1;
               ipquota->time = t;
               ipquota->consumed = 0;
             } else 
               unblockedip = 0;
           }
           sgDbUpdate(s->ipDb, dotnet, (void *) ipquota, 
                      sizeof(struct IpInfo));
         }
       }
      }
    } else
#endif
//fin ip
      foundip = 1;
      if(s->userDb != NULL){
      if(*ident == '\0')
	founduser = 0;
      else {
#ifdef HAVE_LIBLDAP
        if(sgFindUser(s, ident, &userquota)) {
#else
        rfc1738_unescape(ident);
        if(defined(s->userDb, ident, (char **) &userquota) == 1){
#endif
	  founduser = 1;
	  unblockeduser = 1;
	  if(s->userquota.seconds != 0){
            struct UserInfo uq;
	    time_t t = time(NULL) + globalDebugTimeDelta;
	    //sgLogError("status %d time %d lasttime %d consumed %d", userquota->status, userquota->time, userquota->last, userquota->consumed);
	    //sgLogError("renew %d seconds %d", s->userquota.renew, s->userquota.seconds);
	    if(userquota->status == 0){ //first time
	      userquota->status = 1;
	      userquota->time = t;
	      userquota->last = t;
	      //sgLogError("user %s first time %d", ident, userquota->time);
	    } else if(userquota->status == 1){
	      //sgLogError("user %s other time %d %d",ident,userquota->time,t);
	      if(s->userquota.sporadic > 0){
		if(t - userquota->last  < s->userquota.sporadic){
		  userquota->consumed += t - userquota->last;
		  userquota->time = t;
		}
		if(userquota->consumed > s->userquota.seconds){
		  userquota->status = 2; // block this user, time is up
		  unblockeduser = 0;
		}
		userquota->last = t;
		//sgLogError("user %s consumed %d %d",ident,userquota->consumed, userquota->last);
	      } else if(userquota->time + s->userquota.seconds < t){
		sgLogError("time is up user %s blocket", ident);
		userquota->status = 2; // block this user, time is up
		unblockeduser = 0;
	      } 
	    } else {
	      //sgLogError("user %s blocket %d %d %d %d", ident, userquota->status, userquota->time, t, (userquota->time + s->userquota.renew) - t);
	      if(userquota->time + s->userquota.renew < t){ // new chance
		//sgLogError("user %s new chance", ident);
		unblockeduser = 1;
		userquota->status = 1;
		userquota->time = t;
		userquota->consumed = 0;
	      } else 
		unblockeduser = 0;
	    }
	    sgDbUpdate(s->userDb, ident, (void *) userquota, 
                      sizeof(struct UserInfo));
	  }
	}
      }
    } else
      founduser = 1;
    if(s->domainDb != NULL){
      if(*domain == '\0')
	founddomain = 0;
      else {
	if(defined(s->domainDb, domain, (char **) NULL) == 1)
	  founddomain = 1;
      }
    } else
      founddomain = 1;
    if(founduser && foundip && founddomain){
      if(unblockeduser)
	return s;
      else {
	lastActiveSource = s;
	return NULL;
      }
    }
  }
  return NULL;
}



/*destination block funtions */

#if __STDC__
void sgDest(char *dest)
#else
void sgDest(dest)
     char *dest;
#endif
{
  struct Destination *sp;
  if(Dest != NULL){
    if((struct Destination *) sgDestFindName(dest) != NULL)
      sgLogFatal("%s: destination %s is defined in configfile %s",
		   progname,dest, configFile);
  }
  sp = (struct Destination *) sgCalloc(1,sizeof(struct Destination));
  sp->domainlist=NULL;
  sp->urllist=NULL;
  sp->expressionlist=NULL;
  sp->redirect=NULL;
  sp->rewrite=NULL;
  sp->active = 1;
  sp->time = NULL;
  sp->within = 0;
  sp->logfile = NULL;
  sp->next=NULL;
  sp->name = (char  *) sgCalloc(1,strlen(dest) + 1);
  strcpy(sp->name,dest);

  if(Dest == NULL){
    Dest = sp;
    lastDest = sp;
  } else {
    lastDest->next = sp;
    lastDest = sp;
  }
}

void sgDestEnd()
{
 struct Destination *d;
 d = lastDest;
 if(d->domainlist == NULL && d->urllist == NULL && d->expressionlist == NULL
    && d->redirect == NULL && d->rewrite == NULL){
   sgLogError("destblock %s missing active content, set inactive",d->name);
   d->time = NULL;
   d->active = 0;
 }
}

#if __STDC__
void sgDestDomainList(char *domainlist)
#else
void sgDestDomainList(domainlist)
     char *domainlist;
#endif
{
  struct Destination *sp;
  char *dbhome = NULL, *dl = domainlist, *name;
  dbhome = sgSettingGetValue("dbhome");
  sp = lastDest;
  if(dbhome == NULL)
    dbhome = DEFAULT_DBHOME;
 if(domainlist == NULL){
    name = sp->name;
    dl = (char *) sgCalloc(1,strlen("/dest/") + strlen(name) + strlen("/domainlist"));
    strcpy(dl,"/dest/");
    strcat(dl,name);
    strcat(dl,"/domainlist");
    sp->domainlist = (char  *) sgCalloc(1,strlen(dbhome) + strlen("/") + strlen(dl) + 4);
    strcpy(sp->domainlist,dbhome);
    strcat(sp->domainlist,"/");
    strcat(sp->domainlist,dl);
    sgFree(dl);
  } else {
    if (domainlist[0] == '/') {
      sp->domainlist = strdup(domainlist);
    } else {
    sp->domainlist = (char  *) sgCalloc(1,strlen(dbhome) + strlen("/") + strlen(domainlist) + 4);
    strcpy(sp->domainlist,dbhome);
    strcat(sp->domainlist,"/");
    strcat(sp->domainlist,domainlist);
    }
  }
  sp->domainlistDb = (struct sgDb *) sgCalloc(1,sizeof(struct sgDb));
  sp->domainlistDb->type=SGDBTYPE_DOMAINLIST;
  sgLogError("init domainlist %s",sp->domainlist);
  sgDbInit(sp->domainlistDb,sp->domainlist);
  if(sp->domainlistDb->entries == 0) { /* empty database */
    sgLogError("domainlist empty, removed from memory");
    sgFree(sp->domainlistDb);
    sp->domainlistDb = NULL;
  }
}

#if __STDC__
void sgDestUrlList(char *urllist)
#else
void sgDestUrlList(urllist)
     char *urllist;
#endif
{
  struct Destination *sp;
  char *dbhome = NULL, *dl = urllist, *name;
  dbhome = sgSettingGetValue("dbhome");
  sp = lastDest;
  if(dbhome == NULL)
    dbhome = DEFAULT_DBHOME;
  if(urllist == NULL){
    name = sp->name;
    dl = (char *) sgCalloc(1,strlen("/dest/") + strlen(name) + strlen("/urllist"));
    strcpy(dl,"/dest/");
    strcat(dl,name);
    strcat(dl,"/urllist");
    sp->urllist = (char  *) sgCalloc(1,strlen(dbhome) + strlen("/") + strlen(dl) + 4);
    strcpy(sp->urllist,dbhome);
    strcat(sp->urllist,"/");
    strcat(sp->urllist,dl);
    sgFree(dl);
  } else {
    if (urllist[0] == '/') {
      sp->urllist = strdup(urllist);
    } else {
    sp->urllist = (char  *) sgCalloc(1,strlen(dbhome) + strlen("/") + strlen(urllist) + 4);
    strcpy(sp->urllist,dbhome);
    strcat(sp->urllist,"/");
    strcat(sp->urllist,urllist);
    }
  }
  sp->urllistDb = (struct sgDb *) sgCalloc(1,sizeof(struct sgDb));
  sp->urllistDb->type=SGDBTYPE_URLLIST;
  sgLogError("init urllist %s",sp->urllist);
  sgDbInit(sp->urllistDb,sp->urllist);
  if(sp->urllistDb->entries == 0) { /* empty database */
    sgLogError("urllist empty, removed from memory");
    sgFree(sp->urllistDb);
    sp->urllistDb = NULL;
  }
}

#if __STDC__
void sgDestExpressionList(char *exprlist, char *chcase)
#else
void sgDestExpressionList(exprlist, chcase)
     char *exprlist;
     char *chcase;
#endif
{
  FILE *fp;
  char buf[MAX_BUF],errbuf[256];
  struct Destination *sp;
  struct sgRegExp *regexp;
  char *dbhome = NULL, *dl = exprlist, *name, *p;
  int flags = REG_EXTENDED;
  dbhome = sgSettingGetValue("dbhome");
  sp = lastDest;
  if(dbhome == NULL)
    dbhome = DEFAULT_DBHOME;
  if(exprlist == NULL){
    name = sp->name;
    dl = (char *) sgCalloc(1,strlen("/dest/") +strlen(name) + strlen("/expressionlist"));
    strcpy(dl,"/dest/");
    strcat(dl,name);
    strcat(dl,"/expressionlist");
    flags |= REG_ICASE; /* default case insensitive */
    sp->expressionlist = (char  *) sgCalloc(1,strlen(dbhome)+strlen(dl)+10);
    strcpy(sp->expressionlist,dbhome);
    strcat(sp->expressionlist,"/");
    strcat(sp->expressionlist,dl);
    sgFree(dl);
  } else {
    if (exprlist[0] == '/') {
      sp->expressionlist = strdup(exprlist);
    } else {
    sp->expressionlist = (char  *) sgCalloc(1,strlen(dbhome) + strlen("/") + strlen(exprlist) + 4);
    strcpy(sp->expressionlist,dbhome);
    strcat(sp->expressionlist,"/");
    strcat(sp->expressionlist,exprlist);
    }
    if(strncmp(chcase,"c",1))
          flags |= REG_ICASE; /* set case insensitive */
  }
  sgLogError("init expressionlist %s",sp->expressionlist);
  if ((fp = fopen(sp->expressionlist, "r")) == NULL) 
    sgLogFatal("%s: %s", sp->expressionlist, strerror(errno));
  while(fgets(buf, sizeof(buf), fp) != NULL){
    p = (char *) strchr(buf,'\n');
    if(p != NULL && p != buf){
      if(*(p - 1) == '\r') /* removing ^M  */
	p--;
      *p = '\0';
    }
    regexp=sgNewPatternBuffer(buf,flags);
    if(regexp->error){
      regerror(regexp->error,regexp->compiled, errbuf,sizeof(errbuf));
      sgLogError("%s: %s", sp->expressionlist, strerror(errno));
    }
    if(lastDest->regExp == NULL){
      lastDest->regExp = regexp;
      lastRegExpDest = regexp;
    } else {
      lastRegExpDest->next = regexp;
      lastRegExpDest = regexp;
    }
  }
  fclose(fp);
}

#if __STDC__
void sgDestRedirect(char *value)
#else
void sgDestRedirect(value)
     char *value;
#endif
{
  struct Destination *sp;
  sp = lastDest;
  sp->redirect = (char *) sgCalloc(1,strlen(value) + 1);
  strcpy(sp->redirect,value);
}

void sgDestRewrite(char *value){
  struct sgRewrite *rewrite = NULL;
  struct Destination *sp;
  sp = lastDest;
  if((rewrite = sgRewriteFindName(value)) == NULL){
    sgLogFatal("%s: FATAL: Rewrite %s is not defined in configfile %s",
		    progname,value, configFile);
  }
  sp->rewrite = rewrite;
}

#if __STDC__
int sgRegExpMatch(struct sgRegExp *regexp, char *str)
#else
int sgRegExpMatch(regexp, str)
     struct sgRegExp *regexp;
     char *str;
#endif
{
  struct sgRegExp *rp;
  static char errbuf[256];
  int error;
  for(rp = regexp; rp != NULL; rp = rp->next){
    error = regexec(rp->compiled, str, 0,0,0);
    if(error != 0 && error != REG_NOMATCH) {
      regerror(error,rp->compiled, errbuf,sizeof(errbuf));
      sgLogError("Error in regex %30.30s %-60.60s  %d %s\n",rp->pattern,str,error,errbuf);
    }
    if(error == 0) /* match */
      return 1;
  }
  return 0;
}

#if __STDC__
void sgDestTime(char *name, int within)
#else
void sgDestTime(name, within)
     char *name;
     int within;
#endif
{
  struct Time *time = NULL;
  struct Destination *sp;
  sp = lastDest;
  if((time = sgTimeFindName(name)) == NULL){
    sgLogFatal("%s: FATAL: Time %s is not defined in configfile %s",
		    progname,name, configFile);
  }
  sp->within = within;
  sp->time = time;
}

#if __STDC__
struct Destination *sgDestFindName(char *name)
#else
struct Destination *sgDestFindName(name)
     char *name;
#endif
{
  struct Destination *p;
  for(p=Dest; p != NULL; p = p->next){
    if(!strcmp(name,p->name))
      return p;
  }
  return NULL;
}

/*
  Setting functions
*/


#if __STDC__
void sgSetting(char *name, char *value)
#else
void sgSetting(name, value)
     char *name;
     char *value;
#endif
{
  struct Setting *sp;
  if(Setting != NULL){
    if((struct Setting *) sgSettingFindName(name) != NULL)
      sgLogFatal("FATAL: %s: setting %s is defined in configfile %s", progname,name, configFile);
  }
  sp = (struct Setting *) sgCalloc(1,sizeof(struct Setting));

  sp->name = strdup(name);
  sp->value = strdup(value);

// DEBUG
  if(strcmp(name,"ldapbindpass") == 0 || strcmp(name,"mysqlpassword") == 0) {
     sgLogNotice("INFO: New setting: %s: ***************", name);
  }
  else { 
     sgLogNotice("INFO: New setting: %s: %s", name, value);
  }

  if(Setting == NULL){
    Setting = sp;
    lastSetting = sp;
  } else {
    lastSetting->next = sp;
    lastSetting = sp;
  }
  if(!strcmp(name,"logdir")){
    globalLogDir= strdup(value);
  }
#ifdef USE_SYSLOG
  if(!strcmp(name,"syslog")){
    sgSyslogSetting(value);
  }
#endif
}

#ifdef USE_SYSLOG
#if __STDC__
void sgSyslogSetting (char *value)
#else
void sgSyslogSetting (value)
    char *value;
#endif
{
    if (strcmp(value,"enable") == 0){
        //printf(">> enable syslog option\n");
        globalSyslog = 1;
    }
    else if (strcmp(value,"disable") == 0){
        //printf(">> disable syslog option \n");
        globalSyslog = 0;
    }
    else {
        printf("ERROR: Invalid syslog option in %s line %d. Syslog will not be used. See logfile for informations. \n", configFile, lineno);
	globalSyslog = 0;
        sgLogError("ERROR: Invalid syslog option in %s line %d. Syslog will not be used. See logfile for informations. \n", configFile, lineno);
    }
}
#endif


#if __STDC__
struct Setting *sgSettingFindName(char *name)
#else
struct Setting *sgSettingFindName(name)
     char *name;
#endif
{
  struct Setting *p;
  for(p=Setting; p != NULL; p = p->next){
    if(!strcmp(name,p->name))
      return p;
  }
  return NULL;
}


#if __STDC__
char *sgSettingGetValue(char *name)
#else
char *sgSettingGetValue(name)
     char *name;
#endif
{
  struct Setting *p;
  p = sgSettingFindName(name);
  if(p != NULL)
    return p->value;
  return NULL;
}


/*
  
  sgRewrite function

 */

#if __STDC__
void sgRewrite(char *rewrite)
#else
void sgRewrite(rewrite)
     char *rewrite;
#endif
{
  struct sgRewrite *rew;
  if(Rewrite != NULL){
    if((struct sgRewrite *) sgRewriteFindName(rewrite) != NULL)
      sgLogFatal("%s: rewrite %s is defined in configfile %s",
		      progname,rewrite, configFile);
  }
  rew = (struct sgRewrite *) sgCalloc(1,sizeof(struct sgRewrite));
  rew->name = strdup(rewrite);
  rew ->rewrite = NULL;
  rew->logfile = NULL;
  rew->time = NULL;
  rew->active = 1;
  rew->within = 0;
  rew->next=NULL;

  if(Rewrite == NULL){
    Rewrite = rew;
    lastRewrite = rew;
  } else {
    lastRewrite->next = rew;
    lastRewrite = rew;
  }
}

#if __STDC__
void sgRewriteTime(char *name, int within)
#else
void sgRewriteTime(name, within)
     char *name;
     int within;
#endif
{
  struct Time *time = NULL;
  struct sgRewrite *sp;
  sp = lastRewrite;
  if((time = sgTimeFindName(name)) == NULL){
    sgLogFatal("%s: FATAL: Time %s is not defined in configfile %s",
		    progname,name, configFile);
  }
  sp->within = within;
  sp->time = time;
}

#if __STDC__
void sgRewriteSubstitute (char *string)
#else
void sgRewriteSubstitute (string)
     char *string;
#endif
{
  char *pattern, *subst = NULL , *p;
  int flags = REG_EXTENDED ;
  int global = 0;
  char *httpcode = NULL;
  struct sgRegExp *regexp;
  char errbuf[256];
  pattern = string + 2 ; /* skipping s@ */
  p = pattern;
  while((p = strchr(p,'@')) != NULL){
    if(*( p - 1) != '\\'){
      *p = '\0';
      subst = p + 1;
      break;
    }
    p++;
  }
  p= strrchr(subst,'@');
  while(p != NULL && *p != '\0'){
    if(*p == 'r' )
      httpcode =  REDIRECT_TEMPORARILY;
    if(*p == 'R' )
      httpcode =  REDIRECT_PERMANENT;
    if(*p == 'i' || *p == 'I')
      flags |= REG_ICASE;
    if(*p == 'g')
      global = 1;
    *p = '\0'; /*removes @i from string */
    p++;
  } 
  regexp=sgNewPatternBuffer(pattern,flags);
  if(regexp->error){
      regerror(regexp->error,regexp->compiled, errbuf,sizeof(errbuf));
      sgLogError("Error in regexp %s: %s",pattern,errbuf);
  } else {
    regexp->substitute = strdup(subst);
  }
  if(lastRewrite->rewrite == NULL)
    lastRewrite->rewrite = regexp;
  else 
    lastRewriteRegExec->next=regexp;
  regexp->httpcode = httpcode;
  regexp->global = global;
  lastRewriteRegExec = regexp;
}

#if __STDC__
char *sgRewriteExpression(struct sgRewrite *rewrite, char *subst)
#else
char *sgRewriteExpression(rewrite, subst)
     struct sgRewrite *rewrite;
     char *subst;
#endif
{
  char *result = NULL;
  result = sgRegExpSubst(rewrite->rewrite, subst);
  return result;
}

#if __STDC__
struct sgRewrite *sgRewriteFindName(char *name)
#else
struct sgRewrite *sgRewriteFindName(name)
     char *name;
#endif
{
  struct sgRewrite *p;
  for(p=Rewrite; p != NULL; p = p->next){
    if(!strcmp(name,p->name))
      return p;
  }
  return NULL;
}



/*
  Time functions
*/

#if __STDC__
void sgTime(char *name)
#else
void sgTime(name)
     char *name;
#endif
{
  struct Time *t;
  if(Time != NULL){
    if((struct Time *) sgTimeFindName(name) != NULL)
      sgLogFatal("%s: time %s is defined in configfile %s",
		      progname,name, configFile);
  } else 
    numTimeElements = 0;
  t = (struct Time *) sgCalloc(1,sizeof(struct Time));
  t->name = strdup(name);
  t->element = NULL;
  t->active = 1;
  TimeElement = NULL;
  lastTimeElement = NULL;
  if(Time == NULL){
    Time = t;
    lastTime = t;
  } else {
    lastTime->next = t;
    lastTime = t;
  }
}

#if __STDC__
void sgTimeElementInit()
#else
void sgTimeElementInit()
#endif
{
  struct TimeElement *te;
  te = (struct TimeElement *) sgCalloc(1,sizeof(struct TimeElement));
  numTimeElements++;
  if(lastTime->element == NULL)
    lastTime->element = te;
  if(lastTimeElement != NULL)
    lastTimeElement->next = te;
  lastTimeElement = te;
}

#if __STDC__
void sgTimeElementEnd ()
#else
void sgTimeElementEnd ()
#endif
{
  time_switch = 0;
  date_switch = 0;
  if(lastTimeElement->fromdate !=0){
    if(lastTimeElement->todate == 0)
      lastTimeElement->todate = lastTimeElement->fromdate + 86399;
    else 
      lastTimeElement->todate = lastTimeElement->todate + 86399;
  }
  if(lastTimeElement->from == 0 && lastTimeElement->to == 0)
    lastTimeElement->to = 1439; /* set time to 23:59 */
}

#if __STDC__
void sgTimeElementAdd (char *element, char type) 
#else
void sgTimeElementAdd (element, type) 
     char *element;
     char type;
#endif
{
  struct TimeElement *te;
  char *p;
  char wday = 0;
  int h,m,Y,M = 0,D = -1;
  time_t sec;
  te = lastTimeElement;
  switch(type) {
  case T_WEEKDAY:
    p = strtok(element," \t,");
    do {
      if(*p == '*'){
	wday = 127;
      } else if(!strncmp(p,"sun",3)){
	wday = wday | 0x01;
      } else if(!strncmp(p,"mon",3)){
	wday = wday | 0x02;
      } else if(!strncmp(p,"tue",3)){
	wday = wday | 0x04;
      } else if(!strncmp(p,"wed",3)){
	wday = wday | 0x08;
      } else if(!strncmp(p,"thu",3)){
	wday = wday | 0x10;
      } else if(!strncmp(p,"fri",3)){
	wday = wday | 0x20;
      } else if(!strncmp(p,"sat",3)){
	wday = wday | 0x40;
      }
      p=strtok(NULL," \t,");
    } while(p != NULL);
    te->wday = wday;
    break;
  case T_TVAL:
    sscanf(element,"%d:%d",&h,&m);
    if((h < 0 && h > 24) && (m < 0 && m > 59))
      sgLogFatal("%s: FATAL: time formaterror in %s line %d",
		      progname, configFile,lineno);
    if(time_switch == 0){
      time_switch++;
      te->from = (h * 60) + m ;
    } else {
      time_switch=0;
      te->to = (h * 60) + m ;
    }
    break;
  case T_DVAL:
    sec = date2sec(element);
    if(sec == -1){
      sgLogFatal("%s: FATAL: date formaterror in %s line %d",
		      progname, configFile,lineno);
    }
    if(date_switch == 0){
      date_switch++;
      te->fromdate = sec;
    } else {
      date_switch=0;
      te->todate = sec;
    }
    break;
  case T_DVALCRON:
    p = strtok(element,"-.");
    Y = atoi(p);
    if(*p == '*')
      Y = -1;
    else
      Y = atoi(p);
    while((p=strtok(NULL,"-.")) != NULL){
      if(*p == '*')
	if(M == 0)
	  M = -1;
	else 
	  D = -1;
      else
	if(M == 0)
	  M = atoi(p);
	else
	  D = atoi(p);
    }
    te->y=Y; te->m=M; te->d=D;
    break;
  case T_WEEKLY:
    p = element;
    while(*p != '\0'){
      switch(*p){
      case 'S':
      case 's':
	wday = wday | 0x01;
	break;
      case 'M':
      case 'm':
	wday = wday | 0x02;
	break;
      case 'T':
      case 't':
	wday = wday | 0x04;
	break;
      case 'W':
      case 'w':
	wday = wday | 0x08;
	break;
      case 'H':
      case 'h':
	wday = wday | 0x10;
	break;
      case 'F':
      case 'f':
	wday = wday | 0x20;
	break;
      case 'A':
      case 'a':
	wday = wday | 0x40;
	break;
      default:
	sgLogFatal("%s: FATAL: weekday formaterror in %s line %d",
			progname, configFile,lineno);
	break;
      }
      p++;
    }
    te->wday = wday;
    break;
  }
}


#if __STDC__
struct Time *sgTimeFindName(char *name)
#else
struct Time *sgTimeFindName(name)
     char *name;
#endif
{
  struct Time *p;
  for(p=Time; p != NULL; p = p->next){
    if(!strcmp(name,p->name))
      return p;
  }
  return NULL;
}

#if __STDC__
int sgTimeCmp(const int *a, const int *b)
#else
int sgTimeCmp(a, b)
     const int *a;
     const int *b;
#endif
{
  return *a - *b;
}

#if __STDC__
void sgTimeElementSortEvents()
#else
void sgTimeElementSortEvents()
#endif
{
 struct Time *p;
 struct TimeElement *te;
 int i = 0,j;
 int *t;
 if(Time != NULL){
   TimeElementsEvents = (int *) sgCalloc(numTimeElements * 2 , sizeof(int)); 
   t = (int *) sgCalloc(numTimeElements * 2, sizeof(int)); 
   for(p = Time; p != NULL; p = p->next){
     for(te = p->element; te != NULL; te = te->next){
       TimeElementsEvents[i++]= te->from == 0 ? 1440 : te->from;
       TimeElementsEvents[i++]= te->to == 0 ? 1440 : te->to;
     }
   }
   qsort(TimeElementsEvents,numTimeElements * 2,sizeof(int),
	 (void *) &sgTimeCmp);
   for(i=0,j=0; i < numTimeElements * 2; i++){
     if(j==0){
       t[j++] = TimeElementsEvents[i];
     } else {
       if(t[j-1] != TimeElementsEvents[i]){
	 t[j++]=TimeElementsEvents[i];
       }
     }
   }
   sgFree(TimeElementsEvents);
   numTimeElements = j;
   TimeElementsEvents = t;
 }
}

#if __STDC__
int sgTimeNextEvent()
#else
int sgTimeNextEvent()
#endif
{
  time_t t;
  struct tm *lt;
  int m = 0; 
  static int lastval= 0;
  static int index = 0;
#if HAVE_SIGACTION
  struct sigaction act;
#endif
  if(Time == NULL)
    return 0;
  t = time(NULL) + globalDebugTimeDelta;

  lt = localtime(&t); 
  m = (lt->tm_hour * 60) + lt->tm_min ;
  
  for(index=0; index < numTimeElements; index++){
    if(TimeElementsEvents[index] >= m){
      break;
    }
  }
  lastval = TimeElementsEvents[index];
#if HAVE_SIGACTION
#ifndef SA_NODEFER
#define SA_NODEFER 0
#endif
  act.sa_handler = sgAlarm;
  act.sa_flags = SA_NODEFER | SA_RESTART;
  sigaction(SIGALRM, &act, NULL);
#else
#if HAVE_SIGNAL
  signal(SIGALRM, &sgAlarm);
#else
#endif
#endif
  if(lastval < m )
    m = (((1440 - m ) + lastval) * 60) - lt->tm_sec;
  else
    m = ((lastval - m) * 60) - lt->tm_sec;
  if(m <= 0)
    m = 30;
/* nolog option set:  sgLogDebug("INFO: recalculating alarm in %d seconds", (unsigned int)m); */
  alarm((unsigned int) m);
  sgTimeCheck(lt,t);
  sgTimeSetAcl();
  return 0;
}

#if __STDC__
int sgTimeCheck(struct tm *lt, time_t t)
#else
int sgTimeCheck(lt, t)
     struct tm *lt;
     time_t t;
#endif
{
  struct Time *sg;
  struct TimeElement *te;
  int min;
  if(Time == NULL)
    return -1;
  for(sg = Time; sg != NULL; sg = sg->next){
    sg->active = 0;
    for(te = sg->element; te != NULL ; te = te->next){
      if(te->wday != 0){
	if(((1 << lt->tm_wday ) & te->wday) != 0) {
	  min = (lt->tm_hour * 60 ) + lt->tm_min;
	  if(min >= te->from && min < te->to){
	    sg->active = 1;
	    break;
	  }
	}
      } else { /* date */
	if(te->fromdate != 0){
	  if(t >= te->fromdate && t <= te->todate){
	    min = (lt->tm_hour * 60 ) + lt->tm_min;
	    if(min >= te->from && min < te->to){
	      sg->active =1;
	      break;
	    }
	  }
	} else { /* cron */
	  if(te->y == -1 || te->y == (lt->tm_year + 1900)){
	    if(te->m == -1 || te->m == (lt->tm_mon + 1)){
	      if(te->d == -1 || te->d == (lt->tm_mday)){
		min = (lt->tm_hour * 60 ) + lt->tm_min;
		if(min >= te->from && min < te->to){
		  sg->active =1;
		  break;
		}
	      }
	    }
	  }
	}
      }
    }
  }
  return 0;
}

void sgTimeSetAcl()
{
  struct Acl *acl = defaultAcl;
  struct Destination *d;
  struct Source *s;
  struct sgRewrite *rew;
  for(acl=Acl; acl != NULL; acl = acl->next){
    if(acl->time != NULL){
      acl->active = acl->time->active;
      if(acl->within == OUTSIDE){
	if(acl->active){
	  acl->active = 0;
        }
	else {
	  acl->active = 1;
        }
      }
      if(acl->next != NULL && acl->next->within == ELSE){
	if(acl->active == 0){
	  acl->next->active = 1;
	} else {
	  acl->next->active = 0;
	}
      }
    }
  }
  for(d = Dest; d != NULL; d = d->next){
    if(d->time != NULL){
      d->active = d->time->active;
      if(d->within == OUTSIDE){
	if(d->active){
	  d->active = 0;
	} else {
	  d->active = 1;
        }
      }
    }
  }
  for(s = Source; s != NULL; s = s->next){
    if(s->time != NULL){
      s->active = s->time->active;
      if(s->within == OUTSIDE){
	if(s->active){
	  s->active = 0;
        }
	else  {
	  s->active = 1;
        }
      }
    }
  }
  for(rew = Rewrite; rew != NULL; rew = rew->next){
    if(rew->time != NULL){
      rew->active = rew->time->active;
      if(rew->within == OUTSIDE) {
    	if(rew->active)
    	  rew->active = 0;
    	else
    	  rew->active = 1;
      }
    }
  }
}

void sgTimeElementClone() {
  struct TimeElement *te = lastTimeElement, *tmp;
  if ( lastTimeElement == NULL ) {
    sgLogFatal("FATAL: No prev TimeElement in sgTimeElementClone !");
  } else {
    sgTimeElementInit();
    lastTimeElement->wday = te->wday;
    lastTimeElement->from = te->from;
    lastTimeElement->to = te->to;
    lastTimeElement->y = te->y;
    lastTimeElement->m = te->m;
    lastTimeElement->d = te->d;
    lastTimeElement->fromdate = te->fromdate;
    lastTimeElement->todate = te->todate;
    tmp = lastTimeElement;
    lastTimeElement = te;
    sgTimeElementEnd();
    lastTimeElement = tmp;
  }
}

void sgTimePrint() {
  struct Time *t;
  struct TimeElement *te;
  for(t = Time; t != NULL; t = t->next){
    printf("Time %s is ",t->name);
    t->active ? printf("active\n") : printf("inactive\n");
    for(te = t->element; te != NULL; te = te->next){
      printf("\tte->wday     = %x\n",te->wday);
      printf("\tte->from     = %d\n",te->from);
      printf("\tte->to       = %d\n",te->to);
      printf("\tte->y,m,d    = %d-%d-%d\n",te->y,te->m,te->d);
      printf("\tte->fromdate = %s\n",te->fromdate == 0 ?
             "0" : niso(te->fromdate));
      printf("\tte->todate   = %s\n\n",te->todate == 0 ?
             "0" : niso(te->todate));
    }
  }
}


/*
  Ip functions
*/


#if __STDC__
void sgSetIpType(int type, char *file, int line)
#else
void sgSetIpType(type, file, line)
     int type;
     char *file;
     int line;
#endif
{
  struct Ip *ip = sgIpLast(lastSource),*nip;
  char *p;
  char *f = file == NULL ? configFile : file;
  int l = line == 0 ? lineno : line ;
  unsigned long octet, *op = NULL;
  if(type == SG_IPTYPE_HOST)
    ip->mask = 0xffffffff;
  if(type == SG_IPTYPE_RANGE){
    if((op=sgConvDot(ip->str)) == NULL)
      sgLogFatal("%s: FATAL: address error in %s line %d", progname, f,l);
    else 
      ip->mask = *op;
    if(ip->net > ip->mask)
      sgLogFatal("%s: FATAL: iprange error in %s line %d", progname, f,l);
  }
  if(type == SG_IPTYPE_CLASS){
    p=ip->str;
    if(*p == '/')
      p++;
    if((op=sgConvDot(p)) == NULL)
      sgLogFatal("%s: FATAL: address error in %s line %d", progname, f,l);
    else 
      ip->mask = *op;
  }
  if(type == SG_IPTYPE_CIDR){
    p=ip->str;
    if(*p == '/')
      p++;
    octet = atoi(p);
    if(octet < 0 || octet > 32){
      sgLogFatal("%s: FATAL: prefix error /%s in %s line %d", progname,p, f,l);
    }
    if(octet == 32)
      ip->mask = 0xffffffff;
    else
      ip->mask = 0xffffffff ^ (0xffffffff >> octet);
    ip->net = ip->net & ip->mask;
  }
  ip->type = type;
  nip = (struct Ip *) sgCalloc(1,sizeof(struct Ip));
  ip->next = nip ;
}

#if __STDC__
void sgIp(char *name)
#else
void sgIp(name)
     char *name;
#endif
{
  struct Ip *ip;
  unsigned long *op;
  if(lastSource->ip == NULL){
    ip = (struct Ip *) sgCalloc(1,sizeof(struct Ip));
    ip->next = NULL;
    lastSource->ip = ip;
    lastSource->lastip = ip;
  } else {
    ip = sgIpLast(lastSource);
  }
  if(ip->net_is_set == 0){
    ip->net_is_set = 1;
    if((op=sgConvDot(name)) == NULL){
      sgLogFatal("%s: FATAL: address error in %s line %d", progname, configFile,lineno);
    } else 
      ip->net = *op;
  } else {
    ip->str = (char *) sgCalloc(1,strlen(name) + 1);
    strcpy(ip->str,name);
  }
}

#if __STDC__
struct Ip *sgIpLast(struct Source *s)
#else
struct Ip *sgIpLast(s)
     struct Source *s;
#endif
{
  struct Ip *ip,*ret = NULL ;
  for(ip=s->ip; ip != NULL; ip = ip->next)
    ret = ip;
  return ret;
}

/*
  ACL functions
*/


#if __STDC__
void sgAcl(char *name, char *value, int within)
#else
void sgAcl(name, value, within)
     char *name;
     char *value;
     int within;
#endif
{
  struct Acl *acl;
  struct Source *source = NULL;
  struct Time *time = NULL;
  int def = 0;
  char *s;
  if(name != NULL){
    /* due to some strange things in my yacc code */
    if((s=(char *) strchr(name,' ')) != NULL)
      *s='\0';    
    if((s=(char *) strchr(name,'\t')) != NULL)
      *s='\0';    
    /*
    if(Acl != NULL){
      if((struct Acl *) sgAclFindName(name) != NULL){
	sgLogFatal("%s: FATAL: ACL %s is defined in configfile %s",progname,name,configFile);
      }
    }
    */
  }
  if(lastAcl != NULL && name == NULL && within == ELSE) 
    name = lastAcl->name;
  acl = (struct Acl *)sgCalloc(1,sizeof(struct Acl));
  if(!strcmp(name,"default")){
    defaultAcl=acl;
    def++;
  } else {
    if((source = sgSourceFindName(name)) == NULL && !def){
      sgLogFatal("%s: FATAL: ACL source %s is not defined in configfile %s",
		      progname,name, configFile);
    }
  }
  acl->name = sgCalloc(1,strlen(name) + 1);
  strcpy(acl->name,name);
  acl->active = within == ELSE ? 0 : 1;
  acl->source = source;
  acl->pass = NULL;
  acl->rewriteDefault = 1;
  acl->rewrite = NULL;
  acl->redirect = NULL;
  acl->within = within;
  acl->logfile = NULL;
  acl->next = NULL;
  if(value != NULL){
    if((time = sgTimeFindName(value)) == NULL){
      sgLogFatal("%s: FATAL: ACL time %s is not defined in configfile %s",
		      progname,value, configFile);
    }
    acl->time = time;
  }
  if(Acl == NULL){
    Acl = acl;
    lastAcl = acl;
  } else {
    lastAcl->next = acl;
    lastAcl = acl;
  }
}

#if __STDC__
void sgAclSetValue (char *what, char *value, int allowed) 
#else
void sgAclSetValue (what, value, allowed)
     char *what;
     char *value;
     int allowed;
#endif
{
  char *subval = NULL;
  struct Destination *dest = NULL;
  struct sgRewrite *rewrite = NULL;
  struct AclDest *acldest;
  int type = ACL_TYPE_TERMINATOR;
  if(!strcmp(what,"pass")){
    if(!strcmp(value,"any") || !strcmp(value,"all"))
    {
      allowed = 1;
    }
    else if(!strcmp(value,"none"))
    {
      allowed=0;
    }
    else if(!strcmp(value,"in-addr")){
      type = ACL_TYPE_INADDR;
    } else if (!strncmp(value,"dnsbl",5)) {
      subval = strstr(value,":");
      type = ACL_TYPE_DNSBL;
    } else {
      if((dest = sgDestFindName(value)) == NULL){
	sgLogFatal("%s: FATAL: ACL destination %s is not defined in configfile %s",
			progname,value, configFile);
      } 
      type = ACL_TYPE_DEFAULT;
    }

    acldest = sgCalloc(1,sizeof(struct AclDest));
    acldest->name = (char *) sgCalloc(1,strlen(value) + 1);
    strcpy(acldest->name,value);
    acldest->dest = dest;
    acldest->access = allowed;
    acldest->type = type;
    if (type == ACL_TYPE_DNSBL)
    {
      if ((subval==NULL) || (subval[1])=='\0')//Config does not define which dns domain to use
      {
        acldest->dns_suffix = (char *) sgCalloc(1,strlen(".black.uribl.com")+1);
	strcpy(acldest->dns_suffix, ".black.uribl.com");
      } else {
        subval=subval+1;
	if (strspn(subval,".-abcdefghijklmnopqrstuvwxyz0123456789") != strlen(subval)  )
	  {
	   sgLogFatal("%s: FATAL: provided dnsbl \"%s\" doesn't look like a valid domain suffix",progname,subval);
          }
	acldest->dns_suffix = (char *) sgCalloc(1,strlen(subval)+1);
	strcpy(acldest->dns_suffix, ".");
	strcat(acldest->dns_suffix,subval);
      }
    }

    acldest->next = NULL;
    if(lastAcl->pass == NULL){
      lastAcl->pass = acldest;
    } else {
      lastAclDest->next = acldest;
    }
    lastAclDest = acldest;
  }

  if(!strcmp(what,"rewrite")){
    if(!strcmp(value,"none")){
      lastAcl->rewriteDefault = 0;
      lastAcl->rewrite = NULL;
    } else {
      if((rewrite = sgRewriteFindName(value)) == NULL){
	sgLogFatal("%s: FATAL: Rewrite %s is not defined in configfile %s",
			progname,value, configFile);
      }
      lastAcl->rewriteDefault = 0;
      lastAcl->rewrite = rewrite;
    }
  }
  if(!strcmp(what,"redirect")){
    if(strcmp(value,"default")){
      lastAcl->redirect = (char *) sgCalloc(1,strlen(value) + 1);
      strcpy(lastAcl->redirect,value);
    } else {
      lastAcl->redirect= NULL;
    }
  }
}

#if __STDC__
struct Acl *sgAclFindName(char *name)
#else
struct Acl *sgAclFindName(name)
     char *name;
#endif
{
  struct Acl *p;
  for(p=Acl; p != NULL; p = p->next){
    if(!strcmp(name,p->name))
      return p;
  }
  return NULL;
}


#if __STDC__
struct Acl *sgAclCheckSource(struct Source *source)
#else
struct Acl *sgAclCheckSource(source)
     struct Source *source;
#endif
{
  struct Acl *acl = defaultAcl;
  int found = 0;
  if(source != NULL){
    for(acl=Acl; acl != NULL; acl = acl->next){
      if(acl->source == source){
	if(acl->active){
	  found++;
	  break;
	} else {
	  if(acl->next->source == source && acl->next->active != 0){
	    found++;
	    acl=acl->next;
	    break;
	  }
	}
      }
    }
  }
/* nolog option set:
  else {
      if( globalDebug == 1 ) { sgLogError("source not found"); }
       }
*/
  if(!found) {
    acl = defaultAcl;
/* nolog option set:
    if( globalDebug == 1 ) { sgLogError("no ACL matching source, using default"); }
*/
  }
  return acl;
}

char *strip_fqdn(char *domain)
{
  char *result;
  result=strstr(domain,".");
  if (result == NULL)
    return NULL;
  return (result+1);
}

int is_blacklisted(char *domain, char *suffix)
{
  char target[MAX_BUF];
  struct addrinfo *res;
  int result;
  //Copying domain to target
  if (strlen(domain)+strlen(suffix)+1>MAX_BUF)
  {
    //Buffer overflow risk - just return and accept
/* nolog option set:
    if( globalDebug == 1 ) { sgLogError("dnsbl : too long domain name - accepting without actual check"); }
*/
     return(0);
   }
   strncpy(target,domain,strlen(domain)+1);
   strcat(target,suffix);

   result = getaddrinfo(target,NULL,NULL,&res);
   if (result == 0) //Result is defined
   {
     freeaddrinfo(res);
     return 1;
   }
   //If anything fails (DNS server not reachable, any problem in the resolution,
   //let's not block anything.
   return 0;
}

int blocked_by_dnsbl(char *domain, char *suffix)
{
  char *dn=domain;
  while ((dn !=NULL) && (strchr(dn,'.')!=NULL)) //No need to lookup "com.black.uribl.com"
  {
    if (is_blacklisted(dn,suffix))
      return(1);
    dn=strip_fqdn(dn);
  }
  return 0;
}


#if __STDC__
char *sgAclAccess(struct Source *src, struct Acl *acl, struct SquidInfo *req)
#else
char *sgAclAccess(src, acl, req)
     struct Source *src;
     struct Acl *acl;
     struct SquidInfo *req;
#endif
{
  int access = 1,result;
  char *redirect = NULL, *dbdata = NULL, *p;
  struct sgRewrite *rewrite = NULL;
  struct AclDest *aclpass = NULL;
  if(acl == NULL)
    return NULL;
  if(acl->pass == NULL)
    acl->pass = defaultAcl->pass;
  if(acl->pass != NULL){
    for(aclpass = acl->pass; aclpass != NULL; aclpass = aclpass->next){
      if(aclpass->dest != NULL && !aclpass->dest->active)
	continue;
      if(aclpass->type == ACL_TYPE_TERMINATOR){
	access=aclpass->access;
	break;
      }
      if(aclpass->type == ACL_TYPE_INADDR){
	if(req->dot){
	  access=aclpass->access;
	  break;
	}
	continue;
      }
      // http://www.yahoo.fr/ 172.16.2.32 - GET
      if(aclpass->type == ACL_TYPE_DNSBL){
        if (req->dot)
	  continue;
	if (blocked_by_dnsbl(req->domain, aclpass->dns_suffix)){
	  access=0;
	  break;
	}
	continue;
      }
      if(aclpass->dest->domainlistDb != NULL){
	result = defined(aclpass->dest->domainlistDb, req->domain, &dbdata);
       if(result != DB_NOTFOUND) {
         if(result){
           if(aclpass->access){
             access++;
             break; 
           } else {
             access = 0;
             break;
           }
	  }
	}
      else {
      }
      }
      if(aclpass->dest->urllistDb != NULL && access){
       result = defined(aclpass->dest->urllistDb,req->strippedurl, &dbdata);
       if (!result) {
         result = defined(aclpass->dest->urllistDb,req->furl, &dbdata);
       }
       if ((result) && (result != DB_NOTFOUND)) {
    if(aclpass->access){
      access++;
      break;
    } else {
      access = 0;
      break;
    }
  }
       else {
	}
      }
      if(aclpass->dest->regExp != NULL && access){
	if((result = sgRegExpMatch(aclpass->dest->regExp,req->furl)) != 0){
	  if(aclpass->access){
	    access++;
	    break;
	  } else {
	    access = 0;
	    break;
	  }
	}
      }
    }
    if(!access){
      if(dbdata != NULL)
	redirect = dbdata;
      else if(aclpass->dest != NULL && aclpass->dest->redirect != NULL)
	redirect = aclpass->dest->redirect;
      else if(aclpass->dest != NULL && aclpass->dest->rewrite != NULL &&
	      (redirect = 
	       sgRewriteExpression(aclpass->dest->rewrite,req->orig)) != NULL){
	;
      }
      else if(acl->redirect == NULL)
	redirect = defaultAcl->redirect;
      else
	redirect = acl->redirect;
    }
  } else {  /* acl->pass == NULL, probably defaultAcl->pass == NULL */
    access=0;
    redirect = defaultAcl->redirect;
  }
  if(acl->rewrite == NULL)
    rewrite = defaultAcl->rewrite;
  else
    rewrite = acl->rewrite;
  if(rewrite != NULL && access){
    if((p = sgRewriteExpression(rewrite,req->orig)) != NULL){
      redirect = p;
      if(rewrite->logfile != NULL){
	globalLogFile = rewrite->logfile;
       sgLogRequest(globalLogFile,req,acl,aclpass,rewrite,REQUEST_TYPE_REWRITE);
       return redirect;
      }
    }
  } else if(redirect != NULL) {
    redirect = sgParseRedirect(redirect, req, acl, aclpass);
  }
  if(src != NULL && src->logfile != NULL)
    globalLogFile = src->logfile;
  if(aclpass == NULL || aclpass->dest == NULL){
    if(defaultAcl->logfile != NULL)
     globalLogFile = defaultAcl->logfile;
  } else
    if(aclpass->dest->logfile != NULL)
      globalLogFile = aclpass->dest->logfile;
  if(globalLogFile != NULL) {
    if(redirect != NULL) {
      sgLogRequest(globalLogFile,req,acl,aclpass,NULL,REQUEST_TYPE_REDIRECT);
    } else {
      sgLogRequest(globalLogFile,req,acl,aclpass,NULL,REQUEST_TYPE_PASS);
    }
  }
  return redirect;
}

#if __STDC__
void yyerror(char *s)
#else
void yyerror(s)
     char *s;
#endif
{
  sgLogFatal("FATAL: %s in configfile %s line %d",s,configFile,lineno);
}


#if __STDC__
int yywrap()
#else
int yywrap()
#endif
{
  return 1;
}

/* returns 1 if user was found for the specified Source
 * returns a pointer to a UserInfo structure when found
 * handles all LDAP sub-lookups and caching
 */
#if __STDC__
int sgFindUser(struct Source *src, char *ident, struct UserInfo **rval)
#else
int sgFindUser(src, ident, rval)
       struct Source *src;
       char *ident;
       struct UserInfo **rval;
#endif

{
       int i, found;
       int CacheTimeOut;
       char *interval;
       struct UserInfo *userinfo;
       static struct UserInfo info;

/* nolog option set:  sgLogError("DEBUG: sgFindUser called with: %s", ident);  */

       /* defined in the userDB? */
       if(defined(src->userDb, ident, (char **) &userinfo) == 1) {
#ifdef HAVE_LIBLDAP
       /* LDAP user? */
       if(!userinfo->ldapuser) {
          *rval = userinfo;
           return 1;       /* no, return regular user */
       }

       /* from here on, we assume it is an LDAP user */

       /* is this info valid? */
       interval = sgSettingGetValue("ldapcachetime");
       CacheTimeOut = atoi(interval != NULL ? interval : "0");
       if((time(NULL) - userinfo->cachetime) <= CacheTimeOut) {
          if(userinfo->found)
                *rval = userinfo;
          return userinfo->found; /* yes */
       }
#endif
       }
       else {
               userinfo = NULL;        /* no record defined, must add our own*/
       }

       found = 0;                      /* assume not found */

#ifdef HAVE_LIBLDAP
       /* loop through all LDAP URLs and do a search */
       for(i = 0; i < src->ldapuserurlcount; i++) {

               found = sgDoLdapSearch(src->ldapuserurls[i], ident);

               /* cache every search in the user database */
               /* this should be safe, since squid only sends real idents
                  that have been authenticated (?) */

               /* any record defined from above? */
               if(userinfo == NULL) {
                       /* no, must use our own memory */
                       userinfo = &info;
                       info.status = 0;
                       info.time = 0;
                       info.consumed = 0;
                       info.last = 0;
                       info.ldapuser = 1;
                       info.found = found;
                       info.cachetime = time(NULL);
               }
               else {
                       /* yes, just update the found flag */
                       userinfo->found = found;
                       userinfo->cachetime = time(NULL);
               }

               sgDbUpdate(src->userDb, ident, (char *) userinfo,
                       sizeof(struct UserInfo));
               /* nolog option set: sgLogError("Added LDAP source: %s", ident); */

               if(found) {
                       *rval = userinfo;
                       break;
               }
       }
#endif
       return found;
}

#ifdef HAVE_LIBLDAP
/* returns 1 if ip was found for the specified Source
 * returns a pointer to a IpInfo structure when found
 * handles all LDAP sub-lookups and caching
 */
#if __STDC__
int sgFindIp(struct Source *src, char *net, struct IpInfo **rval)
#else
int sgFindIp(src, net, rval)
       struct Source *src;
       char *net;
       struct IpInfo **rval;
#endif

{
       int i, found;
       int CacheTimeOut;
       char *interval;
       struct IpInfo *ipinfo;
       static struct IpInfo info;
/* DEBUG
  sgLogError("debug : sgfindip called with: %s", net);
*/
       /* defined in the ipDB? */
       if(defined(src->ipDb, net, (char **) &ipinfo) == 1) {
               /* LDAP ip? */
               if(!ipinfo->ldapip) {
                       *rval = ipinfo;
                       return 1;       /* no, return regular ip */
               }

               /* from here on, we assume it is an LDAP ip */

               /* is this info valid? */
               interval = sgSettingGetValue("ldapcachetime");
               CacheTimeOut = atoi(interval != NULL ? interval : "0");
               if((time(NULL) - ipinfo->cachetime) <= CacheTimeOut) {
                       if(ipinfo->found)
                               *rval = ipinfo;
                       return ipinfo->found; /* yes */
               }
       }
       else {
               ipinfo = NULL;        /* no record defined, must add our own*/
       }

       found = 0;                      /* assume not found */

       /* loop through all LDAP URLs and do a search */
       for(i = 0; i < src->ldapipurlcount; i++) {

               found = sgDoLdapSearch(src->ldapipurls[i], net);

               /* cache every search in the ip database */
               /* this should be safe, since squid only sends real ip adresses (?) */
               /* any record defined from above? */
               if(ipinfo == NULL) {
                       /* no, must use our own memory */
                       ipinfo = &info;
                       info.status = 0;
                       info.time = 0;
                       info.consumed = 0;
                       info.last = 0;
                       info.ldapip = 1;
                       info.found = found;
                       info.cachetime = time(NULL);
               }
               else {
                       /* yes, just update the found flag */
                       ipinfo->found = found;
                       ipinfo->cachetime = time(NULL);
               }

               sgDbUpdate(src->ipDb, net, (char *) ipinfo,
                       sizeof(struct IpInfo));
               // DEBUG
               sgLogError("Added LDAP source: %s", net);

               if(found) {
                       *rval = ipinfo;
                       break;
               }
       }
       return found;
}

#if __STDC__
static int get_ldap_errno(LDAP *ld)
#else
static int get_ldap_errno(ld)
           LDAP *ld;
#endif

{
  int err = 0;
  if(ld) {
    if(ldap_get_option(ld, LDAP_OPT_ERROR_NUMBER, &err) != LDAP_OPT_SUCCESS)
        err = 0;
  }
  return err;
}

/* 
 * expand_url - expand the %s codes in the given LDAP url
 *
 * Returns:  1 on success, 0 on error
 *
 *   char *expand;             destination buffer for expanded URL
 *   size_t expand_size;       size of dest buffer (sizeof() works here)
 *   char *url;                        original URL (MAXWORDLEN)
 *   char *s_item;             word to replace each occurance of %s with
 */
int expand_url(char *expand, size_t expand_size, const char *url,
              const char *s_item)
{
       int item_length;
       char *end = expand + expand_size;

       item_length = strlen(s_item);

       while (*url && expand < end) {
              if (url[0] == '%' && url[1] == 's') {
                       /* check buffer overrun */
                       if ((expand + item_length) >= end)
                               return 0;
                       strcpy(expand, s_item);
                       expand += item_length;  

                       url += 2;
               }
               else { 
                       *expand++ = *url++;
               }
       }

       if (expand < end) {
               *expand = '\0';         /* null terminate string */
               return 1;
       }
       else {
               return 0;
       }
}


/* does a raw LDAP search and returns 1 if found, 0 if not */
#if __STDC__
int sgDoLdapSearch(const char *url, const char *username)
#else
int sgDoLdapSearch(url, username)
       const char *url;
       const char *username;
#endif
{
       LDAPURLDesc *lud;
       LDAP *ld;
       LDAPMessage *ldapresult, *ldapentry;
       char *binddn = NULL, *bindpass = NULL;
       int ext_i;
       char **ldapvals;
       char buffer[MAX_BUF];
       int found = 0;
       int protoversion = -1;                  /* default to library defaults*/
       char *protosetting;

       /* Which protocol version should we use? */
       protosetting = sgSettingGetValue("ldapprotover");
       if (protosetting != NULL) {
               if (atoi(protosetting) == 3) {
                       protoversion = LDAP_VERSION3;
               }
               else if (atoi(protosetting) == 2) {
                       protoversion = LDAP_VERSION2;
               }
       }

       /* insert the username into the url, if needed... allow multiple %s */
       if (!expand_url(buffer, sizeof(buffer), url, username)) {
               sgLogError("%s: unable to expand LDAP URL: size: %u, username: "
                       "%s url: %s", progname, sizeof(buffer), username, url);
               return found;
       }

       /* Parse RFC2255 LDAP URL */
       if(ldap_url_parse(buffer, &lud)) {
               sgLogError("%s: can't parse LDAP url %s",progname, buffer);
               return found;
       }

       /* get a handle to an LDAP connection */
       if((ld = ldap_init(lud->lud_host, lud->lud_port)) == NULL) {
               sgLogError("%s: ldap_init(%s, %d) failed: %s", progname,
                       lud->lud_host, lud->lud_port, strerror(errno));
               ldap_free_urldesc(lud);
               return found;
       }

       /* force an LDAP protocol version if set */
       if (protoversion != -1) {
               if (ldap_set_option(ld, LDAP_OPT_PROTOCOL_VERSION,
                       &protoversion) != LDAP_OPT_SUCCESS)
               {
                       /* this will enter emergency mode */
                       sgLogFatal("%s: FATAL: ldap_set_option failed: %s",
                               progname, ldap_err2string(get_ldap_errno(ld)));
               }
       }

       /*
        * Set binddn and bindpass with values from the config
        * file. Do this before the URL extentions so that they
        * override on a per-block basis.
        */
       binddn = sgSettingGetValue("ldapbinddn");
       bindpass = sgSettingGetValue("ldapbindpass");

       /* check for supported URL extensions:
        *    bindname=<binddn>      (RFC2255)
        *    x-bindpass=<bindpass>  (user-specific, allowed by RFC2255)
        */
       for(ext_i = 0;
           lud->lud_exts != NULL && lud->lud_exts[ext_i] != NULL;
           ext_i++) {

               char *key = lud->lud_exts[ext_i];
               char *data;

               /* skip over any 'critical' markers */
               if (*key == '!')
                       key++;

               /* find '=' sign (first one is all we care about) */
               data = strchr(key, '=');
               if (data == NULL)
                       continue;       /* invalid extension, skip */
               data++;             /* good extension, get data */

               /* do we recognize the key? */
               if (strncmp(key, "bindname=", 9) == 0)
               {
                       binddn = data;
                       /* nolog option set: sgLogError("Extracted binddn: %s", binddn); */
               }
               else if (strncmp(key, "x-bindpass=", 11) == 0)
               {
                       bindpass = data;
                       /* nolog option set: sgLogError("Extracted x-bindpass: %s", bindpass); */
               }
       }

       /* authenticate to the directory */
       if (ldap_simple_bind_s(ld, binddn, bindpass) != LDAP_SUCCESS) {
               sgLogError("%s: ldap_simple_bind_s failed: %s", progname,
               ldap_err2string(get_ldap_errno(ld)));
               ldap_unbind(ld);
               ldap_free_urldesc(lud);
               return found;
       }

       /* Perform search */
       if(ldap_search_ext_s(ld, lud->lud_dn, lud->lud_scope, lud->lud_filter,
               lud->lud_attrs, 0, NULL, NULL, NULL, -1,
               &ldapresult) != LDAP_SUCCESS) {

/* nolog option set:
               sgLogError("%s: ldap_search_ext_s failed: %s "

                       "(params: %s, %d, %s, %s)",
                       progname, ldap_err2string(get_ldap_errno(ld)),
                       lud->lud_dn, lud->lud_scope, lud->lud_filter,
                       lud->lud_attrs[0]);
*/

               ldap_unbind(ld);
               ldap_free_urldesc(lud);
               return found;
       }

       /* return hash */
       ldapentry = ldap_first_entry(ld, ldapresult);
       if(ldapentry != NULL) {
               /* Use first attribute to get value */
               ldapvals = ldap_get_values(ld, ldapentry, lud->lud_attrs[0]);
               if(ldapvals != NULL) {
                       if(*ldapvals != NULL)
                               found = 1;
                       ldap_value_free(ldapvals);
               }
       }

       /* cleanup */
       ldap_msgfree(ldapresult);
       ldap_unbind(ld);
       ldap_free_urldesc(lud);
       return found;
}

#endif
